#include "IIC.h"

void I2C1_init(void)
{
    I2C_InitTypeDef I2C_InitStructure;
    GPIO_InitTypeDef GPIO_InitStructure;

    I2C_DeInit(I2C1);   
    //RCC_I2CCLKConfig(RCC_I2C1CLK_HSI);
    RCC_I2CCLKConfig(RCC_I2C1CLK_SYSCLK);//rԴO
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2C1, ENABLE);   //ʹI2C1ĕr
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);

    GPIO_PinAFConfig(GPIOB, GPIO_PinSource8, GPIO_AF_1);       //PB6 PB7 ɵڶ_
    GPIO_PinAFConfig(GPIOB, GPIO_PinSource9, GPIO_AF_1);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;
    I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
    I2C_InitStructure.I2C_AnalogFilter = I2C_AnalogFilter_Enable;
    I2C_InitStructure.I2C_DigitalFilter = 0x00;//0x01Ϊ0x00ٶȴ
    I2C_InitStructure.I2C_OwnAddress1 = 0x00;
    I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
    I2C_InitStructure.I2C_Timing = 0x10950C27; //100kHz 0x10950C27; //400kHz
    I2C_Init(I2C1, &I2C_InitStructure);
    I2C_Cmd(I2C1, ENABLE);
}

/**
  * @brief  I2C1ϵĳһĳһʼַжȡһֽڵݵ
  * @param  driver_AddrI2Cַ
  * @param  start_Addrʼֽڵַ
  * @param  number_BytesҪȡֽСһҳ
  * @param  read_BufferŶȡݵָ
  * @retval Ƿȡɹ
  */

void I2C1_Write_Bytes(uint8_t driver_Addr,uint8_t REG_Address,uint8_t REG_data)
{
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_BUSY) != RESET);
    I2C_TransferHandling(I2C1, driver_Addr, 1, I2C_Reload_Mode, I2C_Generate_Start_Write);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_TXIS) == RESET);//
    I2C_SendData(I2C1, REG_Address);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_TCR) == RESET);
    I2C_TransferHandling(I2C1, driver_Addr, 1, I2C_AutoEnd_Mode, I2C_No_StartStop);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_TXIS) == RESET);//
    I2C_SendData(I2C1, REG_data);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_STOPF) == RESET);
	
	  I2C_ClearFlag(I2C1, I2C_ICR_STOPCF);
}

void I2C1_Read_Bytes(uint8_t driver_Addr,uint8_t REG_Address,uint8_t *read_Buffer)
{

    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_BUSY) != RESET);
    I2C_TransferHandling(I2C1, driver_Addr, 1, I2C_SoftEnd_Mode, I2C_Generate_Start_Write);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_TXIS) == RESET);//
    I2C_SendData(I2C1, REG_Address);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_TC) == RESET);
    I2C_TransferHandling(I2C1,driver_Addr, 1, I2C_AutoEnd_Mode, I2C_Generate_Start_Read);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_RXNE) == RESET);
    *read_Buffer = I2C_ReceiveData(I2C1);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_STOPF) == RESET);
	  I2C_ClearFlag(I2C1, I2C_ICR_STOPCF);

}

void I2C1_Mulit_Read_Bytes(uint8_t driver_Addr,uint8_t REG_Address,uint8_t number_Bytes,uint8_t *read_Buffer)
{
    uint8_t read_Num;
	
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_BUSY) != RESET);
    I2C_TransferHandling(I2C1, driver_Addr, 1, I2C_SoftEnd_Mode, I2C_Generate_Start_Write);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_TXIS) == RESET);//
    I2C_SendData(I2C1, REG_Address);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_TC) == RESET);
    I2C_TransferHandling(I2C1,driver_Addr, number_Bytes, I2C_AutoEnd_Mode, I2C_Generate_Start_Read);
	  for(read_Num = 0; read_Num < number_Bytes; read_Num++)
     {			 			 		 
       while(I2C_GetFlagStatus(I2C1, I2C_FLAG_RXNE) == RESET);
       read_Buffer[read_Num] = I2C_ReceiveData(I2C1);
		 }
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_STOPF) == RESET);
	  I2C_ClearFlag(I2C1, I2C_ICR_STOPCF);

}

void I2C1_Mulit_Write_Bytes(uint8_t driver_Addr,uint8_t REG_Address,uint8_t number_Bytes,uint8_t *REG_data)
{
	  uint8_t Date_Num;
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_BUSY) != RESET);
    I2C_TransferHandling(I2C1, driver_Addr, 1, I2C_Reload_Mode, I2C_Generate_Start_Write);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_TXIS) == RESET);//
    I2C_SendData(I2C1, REG_Address);
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_TCR) == RESET);
    I2C_TransferHandling(I2C1, driver_Addr, number_Bytes, I2C_AutoEnd_Mode, I2C_No_StartStop);
    	
	for(Date_Num = 0; Date_Num < number_Bytes; Date_Num++)
     {
			 while(I2C_GetFlagStatus(I2C1, I2C_FLAG_TXIS) == RESET);//
       I2C_SendData(I2C1, REG_data[Date_Num]);
		 }
		 
    while(I2C_GetFlagStatus(I2C1, I2C_FLAG_STOPF) == RESET);	
	  I2C_ClearFlag(I2C1, I2C_ICR_STOPCF);
}