#include "RTC.h"
u8 SynchPrediv;
u8 AsynchPrediv;

void RTC_Config(void)
{	
	 RTC_InitTypeDef RTC_InitStructure;
	 RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);
	 PWR_BackupAccessCmd(ENABLE);
	
	 RCC_LSEConfig(RCC_LSE_ON);
	 while(RCC_GetFlagStatus(RCC_FLAG_LSERDY) == RESET);
	 RCC_RTCCLKConfig(RCC_RTCCLKSource_LSE);
	
	 RTC_InitStructure.RTC_AsynchPrediv = 0x7F;
   RTC_InitStructure.RTC_SynchPrediv = 0xFF;
   RTC_InitStructure.RTC_HourFormat = RTC_HourFormat_24; //RTC_HourFormat_12 
	
   RTC_Init(&RTC_InitStructure);
   RCC_RTCCLKCmd(ENABLE);
   RTC_WaitForSynchro();
}

	/* RTCж *******************************************************/
void RTC_ALARM_IT(void)
{		
	  u32 tempreg;
	  RTC_AlarmTypeDef RTC_AlarmStructure;
	  NVIC_InitTypeDef NVIC_InitStructure;
	  EXTI_InitTypeDef EXTI_InitStructure;	
	
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE); //Դ
    PWR_BackupAccessCmd(ENABLE);   
	   
/* RTC configuration *******************************************************/
    RTC_AlarmCmd(RTC_Alarm_A,DISABLE);
	
    RTC_AlarmStructure.RTC_AlarmTime.RTC_H12     = RTC_H12_AM;
    RTC_AlarmStructure.RTC_AlarmTime.RTC_Seconds =0x05;//ÿӵĵ5뻻
   // RTC_AlarmStructure.RTC_AlarmDateWeekDay = 0x31;
    RTC_AlarmStructure.RTC_AlarmDateWeekDaySel = RTC_AlarmDateWeekDaySel_Date;
    RTC_AlarmStructure.RTC_AlarmMask = RTC_AlarmMask_DateWeekDay|RTC_AlarmMask_Hours|RTC_AlarmMask_Minutes;//
    RTC_SetAlarm(RTC_Format_BCD, RTC_Alarm_A, &RTC_AlarmStructure);		
	  
	  RTC_ClearITPendingBit( RTC_IT_ALRA );
    RTC_ITConfig(RTC_IT_ALRA, ENABLE);		
    RTC_AlarmCmd(RTC_Alarm_A, ENABLE);
		
/* EXTI configuration *******************************************************/
    EXTI_ClearITPendingBit(EXTI_Line17);
    EXTI_InitStructure.EXTI_Line = EXTI_Line17;
    EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
    EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising;
    EXTI_InitStructure.EXTI_LineCmd = ENABLE;
    EXTI_Init(&EXTI_InitStructure);
		RTC_ClearFlag(RTC_FLAG_ALRAF);
		
/* NVIC configuration *******************************************************/		
		NVIC_InitStructure.NVIC_IRQChannel = RTC_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
		
		EXTI_ClearITPendingBit(EXTI_Line17);
		
		
			  RCC->APB1ENR|=1<<28;        //f0f4ڽģʽʱrtcȻѲ http://www.stmcu.org.cn/module/forum/forum.php?mod=viewthread&tid=616823&highlight=stm32f0%2Brtc
        PWR->CR|=1<<8;                           
        RTC->WPR=0xCA;
        RTC->WPR=0x53;
        tempreg=RTC->CR&(0X0F<<12);
        RTC->CR&=~(0XF<<12);      
        RTC->ISR&=~(0X3F<<8);      
        PWR->CR|=1<<2;            
        RTC->CR|=tempreg;            
        RTC->WPR=0xFF; 
}

void RTC_Initializes(void)
{
    RTC_InitTypeDef RTC_InitStructure;
    RTC_DateTimeTypeDef RTC_DateTimeStructure;
	  
    if(RTC_ReadBackupRegister(RTC_BKP_DR0) != RTC_FLAG_BKP)//һϵRTCʼ͹ģʽλ󲻽гʼ
     {
        RTC_Config();                                      /*RTC*/

				RTC_DateTimeStructure.Year = 20;
        RTC_DateTimeStructure.Month = 9;
        RTC_DateTimeStructure.Date = 16;
        RTC_DateTimeStructure.Week = 3;
        RTC_DateTimeStructure.Hour = 15;
        RTC_DateTimeStructure.Minute = 19;
        RTC_DateTimeStructure.Second = 00;

        RTC_SetDateTime(RTC_DateTimeStructure);           /*״γʼRTC(201665  12:00:00)*/

      RTC_WriteBackupRegister(RTC_BKP_DR0, RTC_FLAG_BKP); //д뾭˳ʼı־ֵ
     }
    else
     {
       RTC_WaitForSynchro();                            /*ȴRTCRTC_APBʱͬ*/
     }
}


/************************************************
 RTCʱ
*************************************************/
void RTC_SetDateTime(RTC_DateTimeTypeDef RTC_DateTimeStructure)
{
	  RTC_DateTypeDef RTC_DateStructure;	
	  RTC_TimeTypeDef RTC_TimeStructure;

    RTC_TimeStructure.RTC_H12 = RTC_H12_AM;
    RTC_TimeStructure.RTC_Hours = RTC_DateTimeStructure.Hour;
    RTC_TimeStructure.RTC_Minutes = RTC_DateTimeStructure.Minute;
    RTC_TimeStructure.RTC_Seconds = RTC_DateTimeStructure.Second;
			
    RTC_DateStructure.RTC_Year = RTC_DateTimeStructure.Year;
    RTC_DateStructure.RTC_Month = RTC_DateTimeStructure.Month;
    RTC_DateStructure.RTC_Date =RTC_DateTimeStructure.Date;
    RTC_DateStructure.RTC_WeekDay = RTC_DateTimeStructure.Week;
	
    RTC_SetTime(RTC_Format_BIN, &RTC_TimeStructure);
    RTC_SetDate(RTC_Format_BIN, &RTC_DateStructure);
}

void SaveTime(TimeTypeDef Now)
{   
  	RTC_TimeTypeDef RTC_TimeStructure;
	
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE); //ʱӹRTCʱ޸ʱں,ʱ޸,޸ĲЧֻҪȡڷڻȡʱ,ʱЧ
	  PWR_BackupAccessCmd(ENABLE);

	
    RTC_TimeStructure.RTC_H12 = RTC_H12_AM;
    RTC_TimeStructure.RTC_Hours = Now.HourTens*10+Now.HourOnes;
    RTC_TimeStructure.RTC_Minutes = Now.MinuteTens*10+Now.MinuteOnes;
    RTC_TimeStructure.RTC_Seconds = 0x00;
	
	  RTC_SetTime(RTC_Format_BIN, &RTC_TimeStructure);
}
void SaveDate(TimeTypeDef Now)
{   
	RTC_DateTypeDef RTC_DateStructure;
	
	 RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);
	 PWR_BackupAccessCmd(ENABLE);

   RTC_DateStructure.RTC_Year = 20;
   RTC_DateStructure.RTC_Month = Now.MonthTens*10+Now.MonthOnes;
   RTC_DateStructure.RTC_Date = Now.DateTens*10+Now.DateOnes;
   RTC_DateStructure.RTC_WeekDay = 1;
	 RTC_SetDate(RTC_Format_BIN, &RTC_DateStructure);

}
/************************************************
ȡRTCʱ䣨ڣ
*************************************************/
void RTC_GetDateTime(RTC_DateTimeTypeDef *RTC_DateTimeStructure)
{
    RTC_DateTypeDef RTC_DateStructure;
    RTC_TimeTypeDef RTC_TimeStructure;
	
    RTC_GetTime(RTC_Format_BIN, &RTC_TimeStructure);
    RTC_GetDate(RTC_Format_BIN, &RTC_DateStructure);


    RTC_DateTimeStructure->Year = RTC_DateStructure.RTC_Year;
    RTC_DateTimeStructure->Month = RTC_DateStructure.RTC_Month;
    RTC_DateTimeStructure->Date = RTC_DateStructure.RTC_Date;
    RTC_DateTimeStructure->Week = RTC_DateStructure.RTC_WeekDay;
	
    RTC_DateTimeStructure->Hour = RTC_TimeStructure.RTC_Hours;
    RTC_DateTimeStructure->Minute = RTC_TimeStructure.RTC_Minutes;
    RTC_DateTimeStructure->Second = RTC_TimeStructure.RTC_Seconds;
}



