#include "USART2.h"
#include "GPS.h"

#define UART_RX_LEN 150 

static char NMEA_BUF[UART_RX_LEN]={0}; //ֿ֡ڳGGA֡û꣬Ͳպ֡ʹ֡ʧ
extern char NMEA_GGA[150]; //ֿ֡ڳGGA֡û꣬Ͳպ֡ʹ֡ʧ
extern char NMEA_RMC[150]; //
extern nmea_msg gpsx;
extern u8 GGA_ready;
extern u8 RMC_ready;

static void DMA_config()
{
  DMA_InitTypeDef DMA_InitStructure;
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE); //DMAʱ
  DMA_DeInit(DMA1_Channel5);//DMA1ͨ5
  DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)(&USART2->RDR);//ַ
  DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)NMEA_BUF;//ڴַ
  DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;//dma䷽赽ڴ
  DMA_InitStructure.DMA_BufferSize = UART_RX_LEN;//DMAڴʱĳ
  DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;//DMAģʽ
  DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;//DMAڴģʽ
  DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;//ֳ
  DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;//ڴֳ
  DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;//DMAĴģʽ
  DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh;//DMAȼ
  DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;//DMA2memoryеı
  DMA_Init(DMA1_Channel5,&DMA_InitStructure);
  DMA_Cmd(DMA1_Channel5,ENABLE);//ʹͨ5
}

void USART2_INIT(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;	
    USART_InitTypeDef USART_InitStructure;  //崮ڳʼṹ
	  NVIC_InitTypeDef NVIC_InitStruct;
	
	  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);  //ʹGPIOAʱ
	  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);//ʹUSARTʱ
	
		GPIO_PinAFConfig(GPIOA, GPIO_PinSource2, GPIO_AF_1);//Pɵڶ	TX
		GPIO_PinAFConfig(GPIOA, GPIO_PinSource3, GPIO_AF_1);//óɵڶ  RX	

    /*USART2_TX ->PA2     USART2_RX ->PA3*/			
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2|GPIO_Pin_3;	       //ѡдĬܽ         
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;  // 
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ܽ9ģʽ  
    GPIO_Init(GPIOA, &GPIO_InitStructure);           //úѽṹгʼ		   
    
	  DMA_config();
	  /*ͨѶ*/
    USART_InitStructure.USART_BaudRate = 9600; //
    USART_InitStructure.USART_WordLength = USART_WordLength_8b; //λ8λ
    USART_InitStructure.USART_StopBits = USART_StopBits_1;	//ֹͣλ1λ
    USART_InitStructure.USART_Parity = USART_Parity_No;		//Уλ 
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;//
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;		//ʹܽպͷ

    USART_Init(USART2, &USART_InitStructure);
    USART_ClearFlag(USART2,USART_FLAG_TC);
		
		USART_SetAddress(USART2, 0x0A);//ƥַ 0x0A <LF> зASCII/ PS:0x0D <CR>سASCII
		
		USART_ITConfig(USART2,USART_IT_TC,DISABLE);
    USART_ITConfig(USART2,USART_IT_CM,ENABLE);//ַƥж
    USART_ITConfig(USART2, USART_IT_RXNE, DISABLE);
		
    USART_DMACmd(USART2,USART_DMAReq_Rx,ENABLE);	
    USART_Cmd(USART2, ENABLE);

    /* USART2NVICж */
    NVIC_InitStruct.NVIC_IRQChannel = USART2_IRQn;
    NVIC_InitStruct.NVIC_IRQChannelPriority = 0x02;
    NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStruct);
}

/*********************************************/
void UART2_Send_Str(char *s)
{
 int i=0; 
 while(s[i]!=0)
    {
			while(USART_GetFlagStatus(USART2,USART_FLAG_TC)==RESET);
 	    USART_SendData(USART2,s[i]);
 	    i++;
    } 
}

//2ж ַƥж ƥ任з<LF>
void USART2_IRQHandler(void)
{
  uint16_t Len = 0;
  if(USART_GetITStatus(USART2, USART_IT_CM) != RESET)//ƥж
    {
      USART_ClearITPendingBit(USART2,USART_IT_CM); //ж
      DMA_Cmd(DMA1_Channel5,DISABLE);
      Len = UART_RX_LEN - DMA_GetCurrDataCounter(DMA1_Channel5);
      if(NMEA_BUF[3]=='R' && NMEA_BUF[4]=='M' && NMEA_BUF[5]=='C')//RMC
         {
           NMEA_GPRMC_Analysis(&gpsx,(u8*)NMEA_BUF);
					// memcpy(NMEA_RMC, NMEA_BUF, Len);
					// RMC_ready=1;
         }
      else if(NMEA_BUF[3]=='G' && NMEA_BUF[4]=='G' && NMEA_BUF[5]=='A')//GGA
         {
           NMEA_GPGGA_Analysis(&gpsx,(u8*)NMEA_BUF);
					// memcpy(NMEA_GGA, NMEA_BUF, Len);
					// GGA_ready=1;
         }
      DMA_SetCurrDataCounter(DMA1_Channel5,UART_RX_LEN);//DMA
      DMA_Cmd(DMA1_Channel5,ENABLE);//DMA
    }
}



