#include "math.h"
#include "USART1.H"
#include "systick.h"
#include "IIC.h"
#include "buttom.h"
#include "flash.h"
#include "ADC.h"
#include "RTC.h"
#include "oled.h"
#include "TIMER.h"
#include "TIM_PWM.h"
#include "HALL.h"
#include "WS2812.h"

#define FLASH_PROTECTION  0 //Ƿ

#define ADC_VOLT_CHAN  1

#define SYS_RELOAD 	   0x00ffffff    //systiksHIS/8Ϊʱ	HIS=48MHZ	ÿ1Ϊ8ʱӣ6Ϊ1us 48MHZ Լ2.8
#define SCANTIME_1000MS    6000000 
#define SCANTIME_500MS     3000000
#define SCANTIME_400MS     2400000
#define SCANTIME_300MS     1800000
#define SCANTIME_200MS     1200000
#define SCANTIME_100MS      600000
#define SCANTIME_80MS       480000
#define SCANTIME_50MS       300000
#define SCANTIME_10MS        60000
#define SCANTIME_1MS          6000

#define FLASH_PAGE_1      ((u32)0x0800FC00) //FLASH  ¶ȼٶݴ洢63
#define FLASH_PAGE_2      ((u32)0x0800F800) //FLASH  ̥ѹݴ洢62
#define FLASH_PAGE_3      ((u32)0x0800F400) //FLASH  ݴ洢61
#define FLASH_PAGE_4      ((u32)0x0800F000)
#define FLASH_PAGE_5      ((u32)0x0800EC00)

#define ARRAYSIZE(a) (sizeof(a) / sizeof((a)[0])) //ַ

#define  SW_RESET()        NVIC_SystemReset()  

#define PowerSW_ON() {GPIO_SetBits(GPIOB, GPIO_Pin_5);}   //
#define PowerSW_OFF() {GPIO_ResetBits(GPIOB, GPIO_Pin_5);}

RTC_DateTimeTypeDef Time;
TimeTypeDef Now;

ClockTypeDef TotalClock,CurrentClock,Clock[255];
ClockTypeDef ClockMax,ClockMin,ClockAve,ClockTotal;
u16 MaxNUM=1;
u16 MinNUM=1; 


u16 ClockTimes;//ƴ
u16 NoteTimes; //¼еǰ
NoteHeadTypeDef NoteHead[4];
u8 NoteHeadNum; //ҳ

u16 RATE; //
u8 Ratex100,Ratex10,Ratex1;
u16 RateTimes;

u8 CountdownH,CountdownM,CountdownS;//ʱ
u8 CountHTens,CountHOnes,CountMTens,CountMOnes,CountSTens,CountSOnes;

u8 CycleCount_Work,CycleCount_Rest; //ѭѵ
u8 WorkTens,WorkOnes,RestTens,RestOnes;
u8 CycleCount_Num; //

u8 SW_EN;

s8 page=0;   //ҳ
u8 page_old=0; //ûﵽлͲˢҳ
u8 page_chaged; //л־лʼ

u8 secondflash;//ʱˢ  

u8 PageState=100;     //
u8 NoteState=0;     //¼
u8 ModeState=0;     //¼

float volt;
u8 Voltlum=0;
char DisBuf[20];

void SoftReset(void)
{  
    NVIC_SystemReset(); // λ
}

void PowerSW_Init(void)
{ 
	GPIO_InitTypeDef  GPIO_InitStructure;
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);					  											 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;                 
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT; 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
}


void Flash_OB_Protection()
{
  if(SET != FLASH_OB_GetRDP())
    {
       FLASH_Unlock();
       FLASH_OB_Unlock();

       FLASH_OB_RDPConfig(OB_RDP_Level_1);

       FLASH_OB_Launch();
       FLASH_OB_Lock();
       FLASH_Lock();
    }
}
/**********************************************/	
void IWDG_Int(void)
{
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable); //IWDGȨ
	IWDG_SetPrescaler(IWDG_Prescaler_64);         //40kHZڲʱ64Ƶ
	IWDG_SetReload(1000);//100040kHZʱ64Ƶ1000ΣʱΪ1000*64/40000=1.6s 
  IWDG_ReloadCounter(); //ι
  IWDG_Enable();
}
void IWDG_Feed(void)
{
  IWDG_ReloadCounter(); //ι
}
/**********************************************/
void GetVolt()
{
float ADC_value;
		
  ADC_value=0.004163*ADC_Read(ADC_VOLT_CHAN); //3.3VʱӦ12λADCֵ4095  volt/(100+24)=ADC/24;ADC=(3.3/4095)ADC_value
	//volt=(6*ADC_value+4*volt)/10;//˲
	volt=ADC_value;
}

/**********************************************/
void Sleep_IO_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);  //
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOF, ENABLE);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;												   
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	
  GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	GPIO_Init(GPIOF, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN; 
	GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
}
void enter_stop_mode(void)//ֹͣģʽ
{
	SysTick->CTRL = 0x00;//رնʱ
  SysTick->VAL = 0x00;//val,նʱ	
	OLED_Clear();	
	OLED_Display_Off();
	
	TIM_Cmd(TIM2, DISABLE);
	TIM_Cmd(TIM3, DISABLE);
	TIM_CtrlPWMOutputs(TIM2, DISABLE);	                    //PWM
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3,DISABLE);    //رTIM3  ʱ
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2,DISABLE);    //رTIM2  ʱ
	
	ADC_Cmd(ADC1, DISABLE);	        						//ʧADC
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, DISABLE);	
	//ADC_DeInit(ADC1);
	
	I2C_Cmd(I2C1, DISABLE);//ʧIIC
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2C1, DISABLE);
	
	ClockTimes=0;
	Sleep_IO_Init();//˿
	
	EXIT_KEY_Init();//ⲿж
	
	PowerSW_Init();
 	PowerSW_ON();   //ΧԴ		
		
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR , ENABLE);//Դʱ
	
	//PWR_WakeUpPinCmd(PWR_WakeUpPin_1,ENABLE);  //ʹܻѹܽŹ
	//PWR_ClearFlag(PWR_FLAG_WU);
  //PWR_EnterSTANDBYMode();   //standbyģʽ    
		
	PWR_EnterSTOPMode(PWR_Regulator_LowPower, PWR_STOPEntry_WFI);
	//PWR_EnterSTOPMode(PWR_Regulator_ON, PWR_STOPEntry_WFI);//ͣģʽ WFIȴжϽͣģʽ
} 
u8 IWDGFlag;
/**********************************************/
void SaveSet()
{
	u16 data[15];
  
  data[0]=NoteHeadNum;

	data[1]=Ratex100;
	data[2]=Ratex10;
	data[3]=Ratex1;
	
  data[4]=CountHTens;
	data[5]=CountHOnes;
	data[6]=CountMTens;
	data[7]=CountMOnes;
	data[8]=CountSTens;
	data[9]=CountSOnes;

  data[10]=WorkTens;
	data[11]=WorkOnes;
	data[12]=RestTens;
	data[13]=RestOnes;
	data[14]=IWDGFlag;
	
  Write_Flash(data,15,FLASH_PAGE_5);
}

void ReadSet()
{
  u8 i;
	u16 data[15];
  Read_Flash(data,15,FLASH_PAGE_5);		//1		
	
	for(i=0;i<15;i++)
	{
	  if(data[i]==0xffff)data[i]=0;//һϵΪ0xff
	}
	
  NoteHeadNum=data[0];

	Ratex100=(u8)data[1];
	Ratex10=(u8)data[2];
	Ratex1=(u8)data[3];
	
  CountHTens=(u8)data[4];
	CountHOnes=(u8)data[5];
	CountMTens=(u8)data[6];
	CountMOnes=(u8)data[7];
	CountSTens=(u8)data[8];
	CountSOnes=(u8)data[9];

  WorkTens=(u8)data[10];
	WorkOnes=(u8)data[11];
	RestTens=(u8)data[12];
	RestOnes=(u8)data[13];
	
	IWDGFlag=(u8)data[14];
}


void SaveNote(u8 NotePage)
{
	u16 i;
	u16 data[500];
	u32 Page;
	switch (NotePage)
	{
	  case 0:
			   Page=FLASH_PAGE_1;
		break;
		case 1:
			   Page=FLASH_PAGE_2;
		break;
	  case 2:
			   Page=FLASH_PAGE_3;
		break;
		case 3:
			   Page=FLASH_PAGE_4;
		break;	
	}
	
	RTC_GetDateTime(&Time);
	data[0]=ClockTimes<<8|Time.Hour;
	data[1]=Time.Minute<<8|Time.Second;
	
	//delay_ms(10); //дFLASHҪʱ䣬ʱֻдһֽڣֻһдһҳÿλֻһֽ
	
	for(i=1;i<=ClockTimes;i++)
	   {
		   data[2*i]=Clock[i].ClockM;
			 data[2*i+1]=Clock[i].ClockS<<8|Clock[i].Clock10xMS;		 		 
		 }
	Write_Flash(data,2+2*ClockTimes,Page);	
}
void ReadNoteHead()
{
    u8 i;
	  u16 data[2];//Ҫ	
	  u8 Point; //ǰʱļ¼б϶
	
	  Read_Flash(data,2,FLASH_PAGE_1);		//1	
	  if(data[0]==0xffff)data[0]=0;//һϵΪ0xff
		if(data[1]==0xffff)data[1]=0;//
	
	  if(NoteHeadNum-1>=0)Point=NoteHeadNum-1;
	  else Point=4+(NoteHeadNum-1);
    NoteHead[Point].Times=(uint8_t)(data[0]>>8);
	  NoteHead[Point].H=(uint8_t)data[0];
	  NoteHead[Point].M=(uint8_t)(data[1]>>8);
	  NoteHead[Point].S=(uint8_t)data[1];
	
		Read_Flash(data,2,FLASH_PAGE_2);		//2	
	  if(data[0]==0xffff)data[0]=0;//һϵΪ0xff
		if(data[1]==0xffff)data[1]=0;//
	
	  if(NoteHeadNum-2>=0)Point=NoteHeadNum-2;
	  else Point=4+(NoteHeadNum-2);
    NoteHead[Point].Times=(uint8_t)(data[0]>>8);
	  NoteHead[Point].H=(uint8_t)data[0];
	  NoteHead[Point].M=(uint8_t)(data[1]>>8);
	  NoteHead[Point].S=(uint8_t)data[1];
	
		Read_Flash(data,2,FLASH_PAGE_3);		//3	
		if(data[0]==0xffff)data[0]=0;//һϵΪ0xff
		if(data[1]==0xffff)data[1]=0;//
		
		if(NoteHeadNum-3>=0)Point=NoteHeadNum-3;
	  else Point=4+(NoteHeadNum-3);
    NoteHead[Point].Times=(uint8_t)(data[0]>>8);
	  NoteHead[Point].H=(uint8_t)data[0];
	  NoteHead[Point].M=(uint8_t)(data[1]>>8);
	  NoteHead[Point].S=(uint8_t)data[1];
		
	  Read_Flash(data,2,FLASH_PAGE_4);		//4
	  if(data[0]==0xffff)data[0]=0;//һϵΪ0xff
		if(data[1]==0xffff)data[1]=0;//
		
	  if(NoteHeadNum-4>=0)Point=NoteHeadNum-4;
	  else Point=4+(NoteHeadNum-4);
    NoteHead[Point].Times=(uint8_t)(data[0]>>8);
	  NoteHead[Point].H=(uint8_t)data[0];
	  NoteHead[Point].M=(uint8_t)(data[1]>>8);
	  NoteHead[Point].S=(uint8_t)data[1];
	
}
void ReadNote(NotePage)
{	
	  u8 i;
	  u16 data[2];//Ҫ	
    u32 Page;	
	switch (NotePage)
	{
	  case 0:
			   Page=FLASH_PAGE_1;
		break;
		case 1:
			   Page=FLASH_PAGE_2;
		break;
	  case 2:
			   Page=FLASH_PAGE_3;
		break;
		case 3:			
			   Page=FLASH_PAGE_4;
		break;	
	} 
    	Read_Flash(data,1,Page);
		  if(data[0]==0xffff)data[0]=0;//һϵΪ0xff

			ClockTimes=(uint8_t)(data[0]>>8);//
		for(i=1;i<=ClockTimes;i++)
	   {
			 Read_Flash(data,2,Page+4*i);
			 if(data[0]==0xffff)data[0]=0;//һϵΪ0xff
		   if(data[1]==0xffff)data[1]=0;//
			 
		   Clock[i].ClockM=(uint8_t)data[0];
			 Clock[i].ClockS=(uint8_t)(data[1]>>8);
			 Clock[i].Clock10xMS=(uint8_t)data[1];	 
		 }
}

/**********************************************/
void ShowDateTimePage()
{
	 //OLED_Show16x30ICON(98,0,Voltlum);//ʾͼ
	 //GetVolt();
	 sprintf(DisBuf,"%0.1fV",volt);
	 OLED_ShowString(48,6,DisBuf,16);
	
	 sprintf(DisBuf,"%02d:%02d",Time.Hour,Time.Minute);
	 OLED_ShowString(20,2,DisBuf,32);	
	
	 sprintf(DisBuf,"%02d",Time.Month);
	 OLED_ShowString(32,0,DisBuf,16);
	 OLED_ShowCHinese(48,0,31);//
	 sprintf(DisBuf,"%02d",Time.Date);
	 OLED_ShowString(64,0,DisBuf,16);
	 OLED_ShowCHinese(80,0,32);//
	
	 OLED_ShowCHinese(96,6,33);//˵
   OLED_ShowCHinese(112,6,34);//
	
   OLED_ShowCHinese(0,6,27); //ػ
   OLED_ShowCHinese(16,6,28);//
}

void ShowMenu0Page(u8 x) // x=40
{
	
	OLED_ShowCHinese(40,0,16); // 
	OLED_ShowCHinese(56,0,38); //
  OLED_ShowCHinese(72,0,17);//
	
	OLED_Show32x32ICON(x+8,2,0);
	
	sprintf(DisBuf,"@.....");
	OLED_ShowString(40,6,DisBuf,16);
	
	OLED_ShowCHinese(96,6,12);//ȷ
  OLED_ShowCHinese(112,6,13);//
	
	OLED_ShowCHinese(0,6,23); //л
  OLED_ShowCHinese(16,6,24);//
}

void ShowMenu1Page(u8 x) //
{
	OLED_ShowCHinese(40,0,18); //
	OLED_ShowCHinese(56,0,19); //
  OLED_ShowCHinese(72,0,20);//
	
	OLED_Show32x32ICON(x+8,2,1);//
	
	sprintf(DisBuf,".@....");//
	OLED_ShowString(40,6,DisBuf,16);
	
	OLED_ShowCHinese(96,6,12);//ȷ
  OLED_ShowCHinese(112,6,13);//
	
	OLED_ShowCHinese(0,6,23); //л
  OLED_ShowCHinese(16,6,24);//
}

void ShowMenu2Page(u8 x) //ʱ
{
	OLED_ShowCHinese(40,0,35); //ʱ
	OLED_ShowCHinese(56,0,4); //
  OLED_ShowCHinese(72,0,14);//
	
	OLED_Show32x32ICON(x+8,2,2);//
	
	sprintf(DisBuf,"..@...");//
	OLED_ShowString(40,6,DisBuf,16);
	
	OLED_ShowCHinese(96,6,12);//ȷ
  OLED_ShowCHinese(112,6,13);//
	
	OLED_ShowCHinese(0,6,23); //л
  OLED_ShowCHinese(16,6,24);//
}

void ShowMenu3Page(u8 x) //Ъѵ
{
	OLED_ShowCHinese(32,0,39); //
	OLED_ShowCHinese(48,0,40); //
  OLED_ShowCHinese(64,0,41);//
	OLED_ShowCHinese(80,0,42);//
	
	OLED_Show32x32ICON(x+8,2,6);//
	
	sprintf(DisBuf,"...@..");//
	OLED_ShowString(40,6,DisBuf,16);
	
	OLED_ShowCHinese(96,6,12);//ȷ
  OLED_ShowCHinese(112,6,13);//
	
	OLED_ShowCHinese(0,6,23); //л
  OLED_ShowCHinese(16,6,24);//
}

void ShowMenu4Page(u8 x) //Уʱ
{
	OLED_ShowCHinese(40,0,30); //
	OLED_ShowCHinese(56,0,38); //
  OLED_ShowCHinese(72,0,14);//
	
	OLED_Show32x32ICON(x+8,2,4);//
	
	sprintf(DisBuf,"....@.");//
	OLED_ShowString(40,6,DisBuf,16);
	
	OLED_ShowCHinese(96,6,12);//ȷ
  OLED_ShowCHinese(112,6,13);//
	
	OLED_ShowCHinese(0,6,23); //л
  OLED_ShowCHinese(16,6,24);//
}
void ShowMenu5Page(u8 x) //
{
	OLED_ShowCHinese(40,0,10); //
	OLED_ShowCHinese(56,0,38); //
  OLED_ShowCHinese(72,0,11);//
	
	OLED_Show32x32ICON(x+8,2,5);//
	
	sprintf(DisBuf,".....@");//
	OLED_ShowString(40,6,DisBuf,16);
	
	OLED_ShowCHinese(96,6,12);//ȷ
  OLED_ShowCHinese(112,6,13);//
	
	OLED_ShowCHinese(0,6,23); //л
  OLED_ShowCHinese(16,6,24);//
}

void ClearMenuPage(u8 x) //д
{	
	OLED_Clear32x32ICON(x+8,2);
}


/**********************************************/
void GetClockDate(void) //Сֵ
{
  int i;
	int Sum10xMS=0;
	int SumS=0;
	int SumM=0;
	
  MaxNUM=1;
	MinNUM=1;
	
  TransClock(&Clock[1],&ClockMax);
	TransClock(&Clock[1],&ClockMin);
	TransClock(&Clock[1],&ClockAve);
	
	for(i=1;i<=ClockTimes;i++) //ֵ
    {
			if(ClockMax.ClockM<Clock[i].ClockM){
			    TransClock(&Clock[i],&ClockMax);
			    MaxNUM=i;}
			else if(ClockMax.ClockM==Clock[i].ClockM)
			{
			   if(ClockMax.ClockS<Clock[i].ClockS){
			     TransClock(&Clock[i],&ClockMax);
					 MaxNUM=i;}
				 else if(ClockMax.ClockS==Clock[i].ClockS)
				   {
				     if(ClockMax.Clock10xMS<Clock[i].Clock10xMS){
								TransClock(&Clock[i],&ClockMax);	
                MaxNUM=i;}						 
				   }			
			}
		}
		
	for(i=1;i<=ClockTimes;i++) //Сֵ
    {
			if(ClockMin.ClockM>Clock[i].ClockM){
			    TransClock(&Clock[i],&ClockMin);
			    MinNUM=i;}
			else if(ClockMin.ClockM==Clock[i].ClockM)
			{
			   if(ClockMin.ClockS>Clock[i].ClockS){
			     TransClock(&Clock[i],&ClockMin);
					 MinNUM=i;}
				 else if(ClockMin.ClockS==Clock[i].ClockS)
				   {
				     if(ClockMin.Clock10xMS>Clock[i].Clock10xMS){
								TransClock(&Clock[i],&ClockMin);		
                MinNUM=i;}							 
				   }			
			}
		}
		
	for(i=1;i<=ClockTimes;i++) //ƽֵ
    {
			Sum10xMS+=Clock[i].Clock10xMS;
			if(Sum10xMS>100)
			{ 
				SumS++;
			  Sum10xMS=Sum10xMS%100;
			}
			SumS+=Clock[i].ClockS;
			if(SumS>60)
			{
			  SumS=SumS%60;
			  SumM++;
			}
			SumM+=Clock[i].ClockM;
		}
	  	ClockTotal.ClockM=SumM;
		  ClockTotal.ClockS=SumS;
	  	ClockTotal.Clock10xMS=Sum10xMS;
		
			ClockAve.ClockM=SumM/ClockTimes;
		  ClockAve.ClockS=((SumM%ClockTimes)*60+SumS)/ClockTimes;
		  ClockAve.Clock10xMS=((((SumM%ClockTimes)*60+SumS)%ClockTimes)*100+Sum10xMS)/ClockTimes;
}


void ShowNoteList()
{
				  if(ClockTimes>1)
							GetClockDate(); //2μСֵ
				  else if(ClockTimes>0)
						 {
							 ClearClock(&ClockMax);
						   ClearClock(&ClockMin);
						   ClearClock(&ClockAve);
							 ClearClock(&ClockTotal);
						 }						 
					OLED_Clear();
					if(ClockTimes>0)
						 {
					 	  NoteTimes=1;
						  NoteState=0;  //һҳ
							sprintf(DisBuf,"Total  %02d'%02d\"%02d",ClockTotal.ClockM,ClockTotal.ClockS,ClockTotal.Clock10xMS);
							OLED_ShowString(0,0,DisBuf,16);
					 	  sprintf(DisBuf,"Ave    %02d'%02d\"%02d",ClockAve.ClockM,ClockAve.ClockS,ClockAve.Clock10xMS);
							OLED_ShowString(0,2,DisBuf,16);
					    sprintf(DisBuf,"Max[%02d]%02d'%02d\"%02d",MaxNUM,ClockMax.ClockM,ClockMax.ClockS,ClockMax.Clock10xMS);
	            OLED_ShowString(0,4,DisBuf,16);
					 	  sprintf(DisBuf,"Min[%02d]%02d'%02d\"%02d",MinNUM,ClockMin.ClockM,ClockMin.ClockS,ClockMin.Clock10xMS);
	            OLED_ShowString(0,6,DisBuf,16);	
						 }	
          else if(ClockTimes==0)
						{
						  NoteState=3;  //һҳ
					  	sprintf(DisBuf,"<");
	            OLED_ShowString(0,3,DisBuf,16);	
							
              sprintf(DisBuf,">");
	            OLED_ShowString(116,3,DisBuf,16);							
						}
}

/**********************************************/
u8 PowerMode;
u16 PowerDelay=0;
void GetPowerMode() //ÿ1 κΰťһʱ
{
	if(PageState<10||PageState==100)
	   PowerDelay++;
	
	if(PowerMode==0&&PowerDelay>30) //30û
	 {
	   PowerMode=1;//ʾʱѹ
		 PageState=100;
		 OLED_Clear();	
		 ShowDateTimePage();
	 }	 
	 if(PowerMode==1&&PowerDelay>300) //5û
	 {
		 PowerMode=2;
		 PowerDelay=0;
	   NVIC_SystemReset();	   	 
	 }
}
/**********************************************/
void GetSETTime()
{
		RTC_GetDateTime(&Time);

	  Now.MonthTens=Time.Month/10;
	  Now.MonthOnes=Time.Month%10;

	  Now.DateTens=Time.Date/10;
	  Now.DateOnes=Time.Date%10;
	
	  Now.HourTens=Time.Hour/10;
	  Now.HourOnes=Time.Hour%10;
	
	  Now.MinuteTens=Time.Minute/10;
  	Now.MinuteOnes=Time.Minute%10;
}
/**********************************************/
u16 BEEP_Time=0;
u8  BEEP_STATE=0;
void BEEP(uint16_t freq)
{	
  TIM_PWM_Config(freq,60);
	BEEP_STATE=1;
}

void CheckBEEP(void)
{
	if(BEEP_Time>10&&BEEP_STATE==1)
	  {
			while(TIM_GetCounter(TIM2)<300); //ȴʱ͵ƽرʡ磬жпߵƽʱֹͣʱһֱڵͨ״̬һ´20mA59mA,ٲʱʱһֱΪ59mA;	  	
			DisPWM();
			BEEP_Time=0;
		  BEEP_STATE=0;			
	  }
	LedDis(COLOR_BLACK);
}
/**********************************************/
void GetPage()
{
  u8 key=0;	
	s8 EfficNum=0;
	u8 Point;
	   key=ScanKey();
	 
	if(ScanHALL()==1&&PageState==11)
		 key=2;
	
	if(key==1||key==2)PowerDelay=0;//ʱ
	
	switch(PageState)
	{
		case 100:			   
		     if(key==1)
				 {
					 PageState=0;
					 OLED_Clear();
				   ShowMenu0Page(40);				 
				 }
				 else if(key==2)
				 {
					 PageState=101;
					 OLED_Clear();					  
		       sprintf(DisBuf,"closing....");
	         OLED_ShowString(28,3,DisBuf,16);
				 	 PowerDelay=359;//׼һػ
		       PowerMode=1;
				 }
		break;
		case 0:
			if(key==1)     
         {
					PageState=10; //ģʽ
					OLED_Clear();
					ClearClock(&TotalClock);
					sprintf(DisBuf,"%02d;%02d<%02d",TotalClock.ClockM,TotalClock.ClockS,TotalClock.Clock10xMS);
	        OLED_ShowString(0,2,DisBuf,32);	
					OLED_ShowCHinese(96,6,0); //
          OLED_ShowCHinese(112,6,1);//ʼ
							
          OLED_ShowCHinese(0,6,10); //
          OLED_ShowCHinese(16,6,11);//
				 }
				 else if(key==2)
				 {
					 for(EfficNum=40;EfficNum>-32;)
					 {
						 ShowMenu0Page(EfficNum);
					   delay_ms(5);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
					 for(EfficNum=127;EfficNum>40;)
					 {
						 ShowMenu1Page(EfficNum);
					   delay_ms(5);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
				  PageState=1;
          ShowMenu1Page(40);				 
				 }
		break;
		case 1:
				if(key==1)     
         {
					PageState=20;  //
					OLED_Clear();
					ClearClock(&TotalClock);
					sprintf(DisBuf,"%d",Ratex100);
	        OLED_Show_Negative_String(40,2,DisBuf,32);
					sprintf(DisBuf,"%d",Ratex10);
	        OLED_ShowString(56,2,DisBuf,32);
					sprintf(DisBuf,"%d",Ratex1);
	        OLED_ShowString(72,2,DisBuf,32);
					sprintf(DisBuf,"bpm");
	        OLED_ShowString(88,4,DisBuf,8); 
					 
					OLED_ShowCHinese(96,6,12); //ȷ
          OLED_ShowCHinese(112,6,13);//
							
          OLED_ShowCHinese(0,6,47); //
          OLED_ShowCHinese(16,6,48);//
				 }
				else  if(key==2)
				 {
					for(EfficNum=40;EfficNum>-32;)
					 {
						 ShowMenu1Page(EfficNum);
					   delay_ms(10);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
					 for(EfficNum=127;EfficNum>40;)
					 {
						 ShowMenu2Page(EfficNum);
					   delay_ms(10);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
				  PageState=2;
          ShowMenu2Page(40);			 				
				 }
		break;
		case 2:		 //ʱ
				 if(key==1)
				 {
				  PageState=30;//ʱ			
          OLED_Clear();
					ClearClock(&TotalClock);
					sprintf(DisBuf,"%01d",CountHTens);
	        OLED_Show_Negative_String(0,2,DisBuf,32);
					sprintf(DisBuf,"%01d",CountHOnes);
	        OLED_ShowString(16,2,DisBuf,32);
					 
          sprintf(DisBuf,":");					 
	        OLED_ShowString(32,2,DisBuf,32);
					 
					sprintf(DisBuf,"%01d%01d",CountMTens,CountMOnes);
	        OLED_ShowString(48,2,DisBuf,32);
					 
					sprintf(DisBuf,":");
	        OLED_ShowString(80,2,DisBuf,32);
					 
					sprintf(DisBuf,"%01d%01d",CountSTens,CountSOnes);
	        OLED_ShowString(96,2,DisBuf,32);
					 
					OLED_ShowCHinese(8,0,14); //ʱ					 
					OLED_ShowCHinese(56,0,36); //
					OLED_ShowCHinese(104,0,37); //
					 
          OLED_ShowCHinese(0,6,47); //
          OLED_ShowCHinese(16,6,48);//			
					
					OLED_ShowCHinese(96,6,12); //ȷ
          OLED_ShowCHinese(112,6,13);//
							
					 
				 }
				else  if(key==2)
				 {
					 for(EfficNum=40;EfficNum>-32;)
					 {
						 ShowMenu2Page(EfficNum);
					   delay_ms(5);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
					 
					 for(EfficNum=127;EfficNum>40;)
					 {
						 ShowMenu3Page(EfficNum);
					   delay_ms(5);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
					PageState=3;
          ShowMenu3Page(40);					 
				 }				 
		break;	
		case 3:
				 if(key==1)     
         {   
					   PageState=40;
					   OLED_Clear();
					   OLED_ShowCHinese(30,2,43); //					 
					   OLED_ShowCHinese(46,2,44); //
					   OLED_ShowCHinese(30,4,45); //Ϣ					 
					   OLED_ShowCHinese(46,4,46); //
					   sprintf(DisBuf,"%01d",WorkTens);
	           OLED_Show_Negative_String(70,2,DisBuf,16);
					   sprintf(DisBuf,"%01d",WorkOnes);
	           OLED_ShowString(78,2,DisBuf,16);
					   sprintf(DisBuf,"%01d%01d",RestTens,RestOnes);
	           OLED_ShowString(70,4,DisBuf,16);
					 
             OLED_ShowCHinese(0,6,47); //
             OLED_ShowCHinese(16,6,48);//			
					
				     OLED_ShowCHinese(96,6,12); //ȷ
             OLED_ShowCHinese(112,6,13);//					   
				 }
				else  if(key==2)
				 {
					 
					for(EfficNum=40;EfficNum>-32;)
					 {
						 ShowMenu3Page(EfficNum);
					   delay_ms(5);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
					 	OLED_ShowCHinese(32,0,38); //ѭѵΪ4֣ǰ
	          OLED_ShowCHinese(80,0,38); //
					 for(EfficNum=127;EfficNum>40;)
					 {
						 ShowMenu4Page(EfficNum);
					   delay_ms(5);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
				  PageState=4;
          ShowMenu4Page(40);			 				
				 }
		break;			
		case 4:		 
				  if(key==1)
				 {
				  PageState=50;//У		
          GetSETTime();					 
          OLED_Clear();	
					 					 
	        sprintf(DisBuf,"%02d",Time.Month);
        	OLED_ShowString(32,0,DisBuf,16);
        	OLED_ShowCHinese(48,0,31);//
        	sprintf(DisBuf,"%02d",Time.Date);
	        OLED_ShowString(64,0,DisBuf,16);
	        OLED_ShowCHinese(80,0,32);//
					 
					sprintf(DisBuf,"%01d",Now.HourTens);
	        OLED_Show_Negative_String(20,2,DisBuf,32);					 
	        sprintf(DisBuf,"%01d:%02d",Now.HourOnes,Time.Minute);
	        OLED_ShowString(36,2,DisBuf,32);	
	


          OLED_ShowCHinese(0,6,47); //
          OLED_ShowCHinese(16,6,48);//			
					
					OLED_ShowCHinese(96,6,12); //ȷ
          OLED_ShowCHinese(112,6,13);//
					 
				 }
				else  if(key==2)
				 {
					for(EfficNum=40;EfficNum>-32;)
					 {
						 ShowMenu4Page(EfficNum);
					   delay_ms(5);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
					 for(EfficNum=127;EfficNum>40;)
					 {
						 ShowMenu5Page(EfficNum);
					   delay_ms(5);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
					PageState=5;
          ShowMenu5Page(40);				 
				 }
		break;		
		case 5:
			   if(key==1)
				 {
				  PageState=60;//								 
				 }
				else  if(key==2)
				 {
					for(EfficNum=40;EfficNum>-32;)
					 {
						 ShowMenu5Page(EfficNum);
					   delay_ms(5);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
					 for(EfficNum=127;EfficNum>40;)
					 {
						 ShowMenu0Page(EfficNum);
					   delay_ms(5);
						 ClearMenuPage(EfficNum);
						 EfficNum-=20;
					 }
					PageState=0;
          ShowMenu0Page(40);			 
				 }				
		break;				 		
				 
		case 10:    //0Ŀ¼ δ°
			    if(key==1)     
            {            
             PageState=11; //		
						 ClockTimes=0;
						 ClearClock(&ClockTotal);
						 ClearClock(&CurrentClock);
						 TIM_INIT_Config();
						 OLED_ShowCHinese(96,6,2); //ͣ
             OLED_ShowCHinese(112,6,3);//ֹ
							
						 OLED_ShowCHinese(0,6,4); //
             OLED_ShowCHinese(16,6,5);//
            }		
         else	if(key==2)     
            {				
						  PageState=14;
              OLED_Clear();		
					    OLED_Show32x32ICON(48,2,3);//¼ICON
							
              OLED_ShowCHinese(96,6,8); //¼
              OLED_ShowCHinese(112,6,9);//
							
              OLED_ShowCHinese(0,6,10); //
              OLED_ShowCHinese(16,6,11);//	
					 }
		break;
		case 11: //ƴ
						if(key==1)     
              {            
                PageState=12; //ֹͣ
			          DisTIM3();
		            OLED_ShowCHinese(0,6,6); //
                OLED_ShowCHinese(16,6,7);//λ	
		
		            OLED_ShowCHinese(96,6,25); //
                OLED_ShowCHinese(112,6,26);//								
              }	
					  else if(key==2)     
              { 
                if(ClockTimes<255)								
							  	{
									  ClockTimes++; //ƴ
							   	}									
                TransClock(&CurrentClock,&Clock[ClockTimes]);	
                ClearClock(&CurrentClock);	
								
								sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",ClockTimes,Clock[ClockTimes].ClockM,Clock[ClockTimes].ClockS,Clock[ClockTimes].Clock10xMS);
	              OLED_ShowString(8,0,DisBuf,16);											
              }						
		break;
    case 12: //ֹͣ	
		
					if(key==1)      
            {            
             PageState=11; //ʼ								
						 TIM_INIT_Config();
							
						 OLED_ShowCHinese(96,6,2); //ͣ
             OLED_ShowCHinese(112,6,3);//ֹ
							
						 OLED_ShowCHinese(0,6,4); //
             OLED_ShowCHinese(16,6,5);//
            }	
					else if(key==2) 
            {            
             PageState=13; //λ								
             ClearClock(&TotalClock);
             ClearClock(&CurrentClock);								
             OLED_Clear();
						 sprintf(DisBuf,"%02d;%02d<%02d",TotalClock.ClockM,TotalClock.ClockS,TotalClock.Clock10xMS);//;'  <"
	           OLED_ShowString(0,2,DisBuf,32);	
						 OLED_ShowCHinese(96,6,0); //
             OLED_ShowCHinese(112,6,1);//ʼ
							
             OLED_ShowCHinese(0,6,10); //
             OLED_ShowCHinese(16,6,11);//
							
            }		
		break;    
		case 13:
			      if(key==1)
						{
						 PageState=11; //		
						 ClockTimes=0;
						 TIM_INIT_Config();
						 OLED_ShowCHinese(96,6,2); //ͣ
             OLED_ShowCHinese(112,6,3);//ֹ
							
						 OLED_ShowCHinese(0,6,4); //
             OLED_ShowCHinese(16,6,5);//											
						}
						else if(key==2)
						{
						  PageState=14; //
							
							//ReadSet();// NoteHeadNum
							SaveNote(NoteHeadNum); //	
							NoteHeadNum++;
							if(NoteHeadNum>3)
								NoteHeadNum=0;
							SaveSet();
							
              OLED_Clear();		
							OLED_Show32x32ICON(48,2,3);//¼ICON
							
              OLED_ShowCHinese(96,6,8); //¼
              OLED_ShowCHinese(112,6,9);//
							
              OLED_ShowCHinese(0,6,10); //
              OLED_ShowCHinese(16,6,11);//											
						}		
		break;
		case 14:	
					if(key==1)
					{
						PageState=15;
            ReadNoteHead();
						OLED_Clear();

						sprintf(DisBuf,"[1]%02d:%02d'%02d\"",NoteHead[0].H,NoteHead[0].M,NoteHead[0].S);
	          OLED_Show_Negative_String(0,0,DisBuf,16);	
						sprintf(DisBuf,"[2]%02d:%02d'%02d\"",NoteHead[1].H,NoteHead[1].M,NoteHead[1].S);
	          OLED_ShowString(0,2,DisBuf,16);
						sprintf(DisBuf,"[3]%02d:%02d'%02d\"",NoteHead[2].H,NoteHead[2].M,NoteHead[2].S);
	          OLED_ShowString(0,4,DisBuf,16);
						sprintf(DisBuf,"[4]%02d:%02d'%02d\"",NoteHead[3].H,NoteHead[3].M,NoteHead[3].S);
	          OLED_ShowString(0,6,DisBuf,16);
          }
					else if(key==2)
					{
					 	 PageState=0; //
						 OLED_Clear();
             ShowMenu0Page(40);						
					}
		break;
		case 15:
			if(key==1)
			{		
				  PageState=19;
				  switch(NoteHeadNum)
         { 
	         case 0:
						     ReadNote(3);
					 break;
           case 1:
						     ReadNote(0);
					 break;
					 case 2:
						     ReadNote(1);
					 break;
					 case 3:
						     ReadNote(2);
					 break;
					}
				   OLED_Clear();
					 ShowNoteList(); 				 					 
			}
		  else if(key==2)
			{
				    PageState=16;
						sprintf(DisBuf,"[1]%02d:%02d'%02d\"",NoteHead[0].H,NoteHead[0].M,NoteHead[0].S);
	          OLED_ShowString(0,0,DisBuf,16);	
						sprintf(DisBuf,"[2]%02d:%02d'%02d\"",NoteHead[1].H,NoteHead[1].M,NoteHead[1].S);
	          OLED_Show_Negative_String(0,2,DisBuf,16);
						sprintf(DisBuf,"[3]%02d:%02d'%02d\"",NoteHead[2].H,NoteHead[2].M,NoteHead[2].S);
	          OLED_ShowString(0,4,DisBuf,16);
						sprintf(DisBuf,"[4]%02d:%02d'%02d\"",NoteHead[3].H,NoteHead[3].M,NoteHead[3].S);
	          OLED_ShowString(0,6,DisBuf,16);
			}		
		break;
		case 16:
			if(key==1)
			{		
				  PageState=19;
				  switch(NoteHeadNum)
         { 
	         case 0:
						     ReadNote(2);
					 break;
           case 1:
						     ReadNote(3);
					 break;
					 case 2:
						     ReadNote(0);
					 break;
					 case 3:
						     ReadNote(1);
					 break;
				 }
				   OLED_Clear();
					 ShowNoteList(); 
				          						 
			}
		  else if(key==2)
			{
				    PageState=17;
						sprintf(DisBuf,"[1]%02d:%02d'%02d\"",NoteHead[0].H,NoteHead[0].M,NoteHead[0].S);
	          OLED_ShowString(0,0,DisBuf,16);	
						sprintf(DisBuf,"[2]%02d:%02d'%02d\"",NoteHead[1].H,NoteHead[1].M,NoteHead[1].S);
	          OLED_ShowString(0,2,DisBuf,16);
						sprintf(DisBuf,"[3]%02d:%02d'%02d\"",NoteHead[2].H,NoteHead[2].M,NoteHead[2].S);
	          OLED_Show_Negative_String(0,4,DisBuf,16);
						sprintf(DisBuf,"[4]%02d:%02d'%02d\"",NoteHead[3].H,NoteHead[3].M,NoteHead[3].S);
	          OLED_ShowString(0,6,DisBuf,16);
			}		
		break;
		case 17:
			if(key==1)
			{		
				  PageState=19;	
			    					
				  switch(NoteHeadNum)
         { 
	         case 0:
						     ReadNote(1);
					 break;
           case 1:
						     ReadNote(2);
					 break;
					 case 2:
						     ReadNote(3);
					 break;
					 case 3:
						     ReadNote(0);
					 break;
				 }         	
				   OLED_Clear();
					 ShowNoteList(); 				 
			}
		  else if(key==2)
			{
				   PageState=18;
						sprintf(DisBuf,"[1]%02d:%02d'%02d\"",NoteHead[0].H,NoteHead[0].M,NoteHead[0].S);
	          OLED_ShowString(0,0,DisBuf,16);	
						sprintf(DisBuf,"[2]%02d:%02d'%02d\"",NoteHead[1].H,NoteHead[1].M,NoteHead[1].S);
	          OLED_ShowString(0,2,DisBuf,16);
						sprintf(DisBuf,"[3]%02d:%02d'%02d\"",NoteHead[2].H,NoteHead[2].M,NoteHead[2].S);
	          OLED_ShowString(0,4,DisBuf,16);
						sprintf(DisBuf,"[4]%02d:%02d'%02d\"",NoteHead[3].H,NoteHead[3].M,NoteHead[3].S);
	          OLED_Show_Negative_String(0,6,DisBuf,16);
			}		
		break;
		case 18:
			if(key==1)
			{		
				  PageState=19;	
			    					
				  switch(NoteHeadNum)
         { 
	         case 0:
						     ReadNote(0);
					 break;
           case 1:
						     ReadNote(1);
					 break;
					 case 2:
						     ReadNote(2);
					 break;
					 case 3:
						     ReadNote(3);
					 break;
				 }         	
				   OLED_Clear();
					 ShowNoteList();          						 
			}
		  else if(key==2)
			{
				    PageState=15;
						sprintf(DisBuf,"[1]%02d:%02d'%02d\"",NoteHead[0].H,NoteHead[0].M,NoteHead[0].S);
	          OLED_Show_Negative_String(0,0,DisBuf,16);	
						sprintf(DisBuf,"[2]%02d:%02d'%02d\"",NoteHead[1].H,NoteHead[1].M,NoteHead[1].S);
	          OLED_ShowString(0,2,DisBuf,16);
						sprintf(DisBuf,"[3]%02d:%02d'%02d\"",NoteHead[2].H,NoteHead[2].M,NoteHead[2].S);
	          OLED_ShowString(0,4,DisBuf,16);
						sprintf(DisBuf,"[4]%02d:%02d'%02d\"",NoteHead[3].H,NoteHead[3].M,NoteHead[3].S);
	          OLED_ShowString(0,6,DisBuf,16);
			}		
		break;
		case 19: //¼
				switch(NoteState)
	      {
		     case 0: //1ҳ									    
             if(key==1)     
             { 							
						  OLED_Clear();
              //NoteTimes+=4;							 
              if(ClockTimes-NoteTimes<4)	//һҳ
						   {		
						   	NoteState=2;  //תһҳ							
						   	if(ClockTimes-NoteTimes>=0)
							   {
								 sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	               OLED_ShowString(10,0,DisBuf,16);
							   NoteTimes++; //6
								 if(ClockTimes-NoteTimes>=0)
							    {
								   sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	                 OLED_ShowString(10,2,DisBuf,16);
							     NoteTimes++;//7
								   if(ClockTimes-NoteTimes>=0)
							      {
								     sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	                   OLED_ShowString(10,4,DisBuf,16);
							       NoteTimes++; //8
								     if(ClockTimes-NoteTimes>=0)
							         {
								        sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	                      OLED_ShowString(10,6,DisBuf,16);
							          NoteTimes++;
											 }
										 }
									 }									
							   }
							 	sprintf(DisBuf,"<");
	              OLED_ShowString(0,3,DisBuf,16);	
							
                sprintf(DisBuf,">");
	              OLED_ShowString(116,3,DisBuf,16);
						 }
						 else		//һҳ											 
						 {
							  NoteState=1;
						    OLED_Clear();
						    sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	              OLED_ShowString(10,0,DisBuf,16);	
						    sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+1,Clock[NoteTimes+1].ClockM,Clock[NoteTimes+1].ClockS,Clock[NoteTimes+1].Clock10xMS);
	              OLED_ShowString(10,2,DisBuf,16);
						    sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+2,Clock[NoteTimes+2].ClockM,Clock[NoteTimes+2].ClockS,Clock[NoteTimes+2].Clock10xMS);
	              OLED_ShowString(10,4,DisBuf,16);
						    sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+3,Clock[NoteTimes+3].ClockM,Clock[NoteTimes+3].ClockS,Clock[NoteTimes+3].Clock10xMS);
	              OLED_ShowString(10,6,DisBuf,16);
							 							 
							  sprintf(DisBuf,"<");
	              OLED_ShowString(0,3,DisBuf,16);
							
						    sprintf(DisBuf,">");
	              OLED_ShowString(116,3,DisBuf,16);
						 }
					 }
         if(key==2)	
           {
						  PageState=14;
              OLED_Clear();		
							OLED_Show32x32ICON(48,2,3);//¼ICON
							
              OLED_ShowCHinese(96,6,8); //¼
              OLED_ShowCHinese(112,6,9);//
							
              OLED_ShowCHinese(0,6,10); //
              OLED_ShowCHinese(16,6,11);//	
           }	
					break;
					 
 				  case 1:
					if(key==1)     
            { 							
						 OLED_Clear();	
						 NoteTimes+=4;							
             if(ClockTimes-NoteTimes<4)	//һҳ
						 {		
							NoteState=2;  //תһҳ							
						 	if(ClockTimes-NoteTimes>=0)
							 {
								 sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	               OLED_ShowString(10,0,DisBuf,16);
							   NoteTimes++; //6
								 if(ClockTimes-NoteTimes>=0)
							    {
								   sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	                 OLED_ShowString(10,2,DisBuf,16);
							     NoteTimes++;//7
								   if(ClockTimes-NoteTimes>=0)
							      {
								     sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	                   OLED_ShowString(10,4,DisBuf,16);
							       NoteTimes++; //8
								     if(ClockTimes-NoteTimes>=0)
							         {
								        sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	                      OLED_ShowString(10,6,DisBuf,16);
							          NoteTimes++;
											 }											 
										 }
									 }								
							   }
							 	sprintf(DisBuf,"<");
	              OLED_ShowString(0,3,DisBuf,16);	
							
                sprintf(DisBuf,">");
	              OLED_ShowString(116,3,DisBuf,16);
						 }
						 else		//һҳ											 
						 {
							  NoteState=1;
						    OLED_Clear();							 
						    sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	              OLED_Show_Negative_String(10,0,DisBuf,16);	
						    sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+1,Clock[NoteTimes+1].ClockM,Clock[NoteTimes+1].ClockS,Clock[NoteTimes+1].Clock10xMS);
	              OLED_ShowString(10,2,DisBuf,16);
						    sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+2,Clock[NoteTimes+2].ClockM,Clock[NoteTimes+2].ClockS,Clock[NoteTimes+2].Clock10xMS);
	              OLED_ShowString(10,4,DisBuf,16);
						    sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+3,Clock[NoteTimes+3].ClockM,Clock[NoteTimes+3].ClockS,Clock[NoteTimes+3].Clock10xMS);
	              OLED_ShowString(10,6,DisBuf,16);
							 							 
							  sprintf(DisBuf,"<");
	              OLED_ShowString(0,3,DisBuf,16);
							
						    sprintf(DisBuf,">");
	              OLED_ShowString(116,3,DisBuf,16);
						 }
					 }
					if(key==2)
					{
						  OLED_Clear();
							if(NoteTimes>4)
								{
									NoteTimes=NoteTimes-4;
									sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	                OLED_ShowString(10,0,DisBuf,16);	
						      sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+1,Clock[NoteTimes+1].ClockM,Clock[NoteTimes+1].ClockS,Clock[NoteTimes+1].Clock10xMS);
	                OLED_ShowString(10,2,DisBuf,16);
						      sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+2,Clock[NoteTimes+2].ClockM,Clock[NoteTimes+2].ClockS,Clock[NoteTimes+2].Clock10xMS);
	                OLED_ShowString(10,4,DisBuf,16);
						      sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+3,Clock[NoteTimes+3].ClockM,Clock[NoteTimes+3].ClockS,Clock[NoteTimes+3].Clock10xMS);
								  OLED_ShowString(10,6,DisBuf,16);
									sprintf(DisBuf,"<");
	                OLED_ShowString(0,3,DisBuf,16);	
							 
                  sprintf(DisBuf,">");
	                OLED_ShowString(116,3,DisBuf,16);		
								}
								else
								{
										NoteState=0; 
										NoteTimes=1;
									  OLED_Clear();	
						      	sprintf(DisBuf,"Total  %02d'%02d\"%02d",ClockTotal.ClockM,ClockTotal.ClockS,ClockTotal.Clock10xMS);
						      	OLED_ShowString(0,0,DisBuf,16);
					 	        sprintf(DisBuf,"Ave    %02d'%02d\"%02d",ClockAve.ClockM,ClockAve.ClockS,ClockAve.Clock10xMS);
						      	OLED_ShowString(0,2,DisBuf,16);
					          sprintf(DisBuf,"Max[%02d]%02d'%02d\"%02d",MaxNUM,ClockMax.ClockM,ClockMax.ClockS,ClockMax.Clock10xMS);
	                  OLED_ShowString(0,4,DisBuf,16);
					 	        sprintf(DisBuf,"Min[%02d]%02d'%02d\"%02d",MinNUM,ClockMin.ClockM,ClockMin.ClockS,ClockMin.Clock10xMS);
	                  OLED_ShowString(0,6,DisBuf,16);																
								}
					}
				 break;
				 case 2: //һҳ
					 		 if(key==1)     
                 { 
						      PageState=14;
                  OLED_Clear();		
					     		OLED_Show32x32ICON(48,2,3);//¼ICON
							
                  OLED_ShowCHinese(96,6,8); //¼
                  OLED_ShowCHinese(112,6,9);//
							
                  OLED_ShowCHinese(0,6,10); //
                  OLED_ShowCHinese(16,6,11);//	
						     }
								if(key==2)
								{
									if(NoteTimes<=5)
									{
										NoteState=0; 
										NoteTimes=1;
										OLED_Clear();
						      	sprintf(DisBuf,"Total  %02d'%02d\"%02d",ClockTotal.ClockM,ClockTotal.ClockS,ClockTotal.Clock10xMS);
						      	OLED_ShowString(0,0,DisBuf,16);
					 	        sprintf(DisBuf,"Ave    %02d'%02d\"%02d",ClockAve.ClockM,ClockAve.ClockS,ClockAve.Clock10xMS);
						      	OLED_ShowString(0,2,DisBuf,16);
					          sprintf(DisBuf,"Max[%02d]%02d'%02d\"%02d",MaxNUM,ClockMax.ClockM,ClockMax.ClockS,ClockMax.Clock10xMS);
	                  OLED_ShowString(0,4,DisBuf,16);
					      	  sprintf(DisBuf,"Min[%02d]%02d'%02d\"%02d",MinNUM,ClockMin.ClockM,ClockMin.ClockS,ClockMin.Clock10xMS);
	                  OLED_ShowString(0,6,DisBuf,16);		
										
									}
							    else //ǵһҳ
								   {
										NoteState=1;
										 if(ClockTimes%4==0)
											 NoteTimes=NoteTimes-8;
										else 
											NoteTimes=NoteTimes-(ClockTimes%4)-4;
                    OLED_Clear();
						        sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes,Clock[NoteTimes].ClockM,Clock[NoteTimes].ClockS,Clock[NoteTimes].Clock10xMS);
	                  OLED_ShowString(10,0,DisBuf,16);	
						        sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+1,Clock[NoteTimes+1].ClockM,Clock[NoteTimes+1].ClockS,Clock[NoteTimes+1].Clock10xMS);
	                  OLED_ShowString(10,2,DisBuf,16);
						        sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+2,Clock[NoteTimes+2].ClockM,Clock[NoteTimes+2].ClockS,Clock[NoteTimes+2].Clock10xMS);
	                  OLED_ShowString(10,4,DisBuf,16);
						        sprintf(DisBuf,"[%02d] %02d'%02d\"%02d",NoteTimes+3,Clock[NoteTimes+3].ClockM,Clock[NoteTimes+3].ClockS,Clock[NoteTimes+3].Clock10xMS);
	                  OLED_ShowString(10,6,DisBuf,16);	
								    sprintf(DisBuf,"<");
	                  OLED_ShowString(0,3,DisBuf,16);
							
						        sprintf(DisBuf,">");
	                  OLED_ShowString(116,3,DisBuf,16);																					
							     }
								 }
					break;		
				  case 3:
						     if(key==1||key==2)
								 {
						       PageState=14;
                   OLED_Clear();		
					      	 OLED_Show32x32ICON(48,2,3);//¼ICON
							
                   OLED_ShowCHinese(96,6,8); //¼
                   OLED_ShowCHinese(112,6,9);//
							
                   OLED_ShowCHinese(0,6,10); //
                   OLED_ShowCHinese(16,6,11);//	
						     }					
					break; 
        }	
		break;	
    case 20: //λ
			     if(key==1)     
             { 
							 PageState=21;
							 sprintf(DisBuf,"%d",Ratex100);
	             OLED_ShowString(40,2,DisBuf,32);
					     sprintf(DisBuf,"%d",Ratex10);
	             OLED_Show_Negative_String(56,2,DisBuf,32);
					     sprintf(DisBuf,"%d",Ratex1);
	             OLED_ShowString(72,2,DisBuf,32);
							 
				     	 OLED_ShowCHinese(96,6,12); //ȷ
               OLED_ShowCHinese(112,6,13);//
			 				
               OLED_ShowCHinese(0,6,47); //
               OLED_ShowCHinese(16,6,48);//
						 }
            else if(key==2)		
						{
							 PageState=20;
						   Ratex100++;
							 if(Ratex100>9)
								  Ratex100=0;
               sprintf(DisBuf,"%d",Ratex100);
	             OLED_Show_Negative_String(40,2,DisBuf,32);											
						}							
    break;	
    case 21: //10λ
			     if(key==1)     
             { 
							 PageState=22;
							 sprintf(DisBuf,"%d",Ratex100);
	             OLED_ShowString(40,2,DisBuf,32);
					     sprintf(DisBuf,"%d",Ratex10);
	             OLED_ShowString(56,2,DisBuf,32);
					     sprintf(DisBuf,"%d",Ratex1);
	             OLED_Show_Negative_String(72,2,DisBuf,32);
							 
				     	 OLED_ShowCHinese(96,6,12); //ȷ
               OLED_ShowCHinese(112,6,13);//
							
               OLED_ShowCHinese(0,6,47); //
               OLED_ShowCHinese(16,6,48);//
						 }
            else if(key==2)		
						{
							 PageState=21;
						   Ratex10++;
							 if(Ratex10>9)
								  Ratex10=0;
               sprintf(DisBuf,"%d",Ratex10);
	             OLED_Show_Negative_String(56,2,DisBuf,32);											
						}							
    break;	
    case 22: //λ
			     if(key==1)     
             { 
							 PageState=23;
							 SaveSet();
							 RATE=Ratex100*100+Ratex10*10+Ratex1;
							 sprintf(DisBuf,"%03d",RATE);
	             OLED_ShowString(40,2,DisBuf,32);
							 sprintf(DisBuf,"bpm");
	             OLED_ShowString(88,4,DisBuf,8);
							 					
					     OLED_ShowCHinese(96,6,0); //
               OLED_ShowCHinese(112,6,1);//ʼ
							
               OLED_ShowCHinese(0,6,10); //
               OLED_ShowCHinese(16,6,11);//
						 }
            else if(key==2)		
						{
							 PageState=22;
						   Ratex1++;
							 if(Ratex1>9)
								  Ratex1=0;
               sprintf(DisBuf,"%d",Ratex1);
	             OLED_Show_Negative_String(72,2,DisBuf,32);											
						}							
    break;						
		case 23:	//׼    
						if(key==1)      
            {            
             PageState=24; //							 
						 TIM_INIT_Config();
						 
						 OLED_ShowCHinese(0,6,38); //
             OLED_ShowCHinese(16,6,38);//
						 OLED_ShowCHinese(96,6,2); //ͣ
             OLED_ShowCHinese(112,6,3);//ֹ							
            }	
						else if(key==2)  //
						{
						 PageState=1; //
						 OLED_Clear();
             ShowMenu1Page(40);						
						}
		break;
		case 24:  //
			      if(key==1)
						{
						   PageState=25; //ֹͣ
			         DisTIM3();
							 BEEP_Time=12;
							
		           OLED_ShowCHinese(0,6,6); //
               OLED_ShowCHinese(16,6,7);//λ	
		
		           OLED_ShowCHinese(96,6,25); //
               OLED_ShowCHinese(112,6,26);//																			
						}		
		break;
		case 25:
			     if(key==1)
					 {
					   PageState=24; //							 
						 TIM_INIT_Config();
						 						 						 
						 OLED_ShowCHinese(0,6,38); //
             OLED_ShowCHinese(16,6,38);//
						 OLED_ShowCHinese(96,6,2); //ͣ
             OLED_ShowCHinese(112,6,3);//ֹ					 					 
					 }
					 else if(key==2)
					 {
					   	 PageState=23;
						   ClearClock(&TotalClock);							 
							 RATE=Ratex100*100+Ratex10*10+Ratex1;
							 sprintf(DisBuf,"%03d",RATE);
	             OLED_ShowString(40,2,DisBuf,32);
							 sprintf(DisBuf,"bpm");
	             OLED_ShowString(88,4,DisBuf,8);	
						 
					     OLED_ShowCHinese(96,6,0); //
               OLED_ShowCHinese(112,6,1);//ʼ
							
               OLED_ShowCHinese(0,6,10); //
               OLED_ShowCHinese(16,6,11);// 					 
					 }		
    break;	
    case 30: //ʱ
           	 if(key==1)     
             { 	
							 PageState=31;						 
					     sprintf(DisBuf,"%01d",CountHTens);
	             OLED_ShowString(0,2,DisBuf,32);							 
							 sprintf(DisBuf,"%01d",CountHOnes);
	             OLED_Show_Negative_String(16,2,DisBuf,32);											 
						 }
            else if(key==2)		
						{							 
						   CountHTens++;
							 if(CountHTens>9)
								  CountHTens=0;
               sprintf(DisBuf,"%01d",CountHTens);
	             OLED_Show_Negative_String(0,2,DisBuf,32);											
						}	
		break;
    case 31: //ʱ
           	 if(key==1)     
             { 	
							 PageState=32;						 
					     sprintf(DisBuf,"%01d",CountHOnes);
	             OLED_ShowString(16,2,DisBuf,32);							 
							 sprintf(DisBuf,"%01d",CountMTens);
	             OLED_Show_Negative_String(48,2,DisBuf,32);											 
						 }
            else if(key==2)		
						{							 
						   CountHOnes++;
							 if(CountHOnes>9)
								  CountHOnes=0;
               sprintf(DisBuf,"%01d",CountHOnes);
	             OLED_Show_Negative_String(16,2,DisBuf,32);											
						}						
    break;
		case 32: //ʱ
           	 if(key==1)     
             { 	
							 PageState=33;						 
					     sprintf(DisBuf,"%01d",CountMTens);
	             OLED_ShowString(48,2,DisBuf,32);							 
							 sprintf(DisBuf,"%01d",CountMOnes);
	             OLED_Show_Negative_String(64,2,DisBuf,32);											 
						 }
            else if(key==2)		
						{							 
						   CountMTens++;
							 if(CountMTens>5)
								  CountMTens=0;
               sprintf(DisBuf,"%01d",CountMTens);
	             OLED_Show_Negative_String(48,2,DisBuf,32);											
						}	
		break;
		case 33: //ʱ
           	 if(key==1)     
             { 	
							 PageState=34;						 
					     sprintf(DisBuf,"%01d",CountMOnes);
	             OLED_ShowString(64,2,DisBuf,32);							 
							 sprintf(DisBuf,"%01d",CountSTens);
	             OLED_Show_Negative_String(96,2,DisBuf,32);											 
						 }
            else if(key==2)		
						{							 
						   CountMOnes++;
							 if(CountMOnes>9)
								  CountMOnes=0;
               sprintf(DisBuf,"%01d",CountMOnes);
	             OLED_Show_Negative_String(64,2,DisBuf,32);											
						}						
    break;
		case 34: //ʱ
           	 if(key==1)     
             { 	
							 PageState=35;						 
					     sprintf(DisBuf,"%01d",CountSTens);
	             OLED_ShowString(96,2,DisBuf,32);							 
							 sprintf(DisBuf,"%01d",CountSOnes);
	             OLED_Show_Negative_String(112,2,DisBuf,32);											 
						 }
            else if(key==2)		
						{							 
						   CountSTens++;
							 if(CountSTens>5)
								  CountSTens=0;
               sprintf(DisBuf,"%01d",CountSTens);
	             OLED_Show_Negative_String(96,2,DisBuf,32);											
						}	
		break;
		case 35: //ʱ
           	 if(key==1)     
             { 	
							 PageState=36;						 
					     sprintf(DisBuf,"%01d",CountSOnes);
	             OLED_ShowString(112,2,DisBuf,32);	
							 
					     OLED_ShowCHinese(96,6,0); //
               OLED_ShowCHinese(112,6,1);//ʼ
							
               OLED_ShowCHinese(0,6,10); //
               OLED_ShowCHinese(16,6,11);//							 
						 }
            else if(key==2)		
						{							 
						   CountSOnes++;
							 if(CountSOnes>9)
								  CountSOnes=0;
               sprintf(DisBuf,"%01d",CountSOnes);
	             OLED_Show_Negative_String(112,2,DisBuf,32);											
						}						
    break;
		case 36:
			     if(key==1)      
            {            
             PageState=37; //		
						 SaveSet();
             CountdownS=CountSTens*10+CountSOnes;
						 CountdownM=CountMTens*10+CountMOnes;
						 CountdownH=CountHTens*10+CountHOnes;	
							
						 sprintf(DisBuf,"%02d",CountdownH);
	           OLED_ShowString(0,2,DisBuf,32);
				     sprintf(DisBuf,"%02d",CountdownM);
	           OLED_ShowString(48,2,DisBuf,32);
					   sprintf(DisBuf,"%02d",CountdownS);
	           OLED_ShowString(96,2,DisBuf,32);
							
						 TIM_INIT_Config();
						 BEEP_Time=12;//ط
							
						 OLED_ShowCHinese(0,6,38); //
             OLED_ShowCHinese(16,6,38);//
							
						 OLED_ShowCHinese(96,6,2); //ͣ
             OLED_ShowCHinese(112,6,3);//ֹ							
            }	
						else if(key==2)  //
						{
						 PageState=2; //
						 OLED_Clear();
						 BEEP_Time=12;//ط
             ShowMenu2Page(40);						
						}
		break;
		case 37:  //		      			        
			      if(key==1)
						{
						   PageState=38; //ֹͣ
			         DisTIM3();
							
		           OLED_ShowCHinese(0,6,6); //
               OLED_ShowCHinese(16,6,7);//λ	
		
		           OLED_ShowCHinese(96,6,25); //
               OLED_ShowCHinese(112,6,26);//																			
						}		
		break;	
		case 38:
			     if(key==1)
					 {
					   PageState=37; //	
						 TIM_INIT_Config();

						 OLED_ShowCHinese(0,6,38); //
             OLED_ShowCHinese(16,6,38);//
						 
						 OLED_ShowCHinese(96,6,2); //ͣ
             OLED_ShowCHinese(112,6,3);//ֹ					 					 
					 }
					else  if(key==2)  //λ
					 {
					   	 PageState=36;
						 
               CountdownS=CountSTens*10+CountSOnes;
						   CountdownM=CountMTens*10+CountMOnes;
						   CountdownH=CountHTens*10+CountHOnes;		
						 
               ClearClock(&TotalClock);	
						 
					     sprintf(DisBuf,"%02d",CountdownH);
	             OLED_ShowString(0,2,DisBuf,32);
				       sprintf(DisBuf,"%02d",CountdownM);
	             OLED_ShowString(48,2,DisBuf,32);
					     sprintf(DisBuf,"%02d",CountdownS);
	             OLED_ShowString(96,2,DisBuf,32);
						 
					     OLED_ShowCHinese(96,6,0); //
               OLED_ShowCHinese(112,6,1);//ʼ
							
               OLED_ShowCHinese(0,6,10); //
               OLED_ShowCHinese(16,6,11);// 					 
					 }		
    break;	
		case 40:
			    if(key==1)
						{
						 PageState=41;
					   sprintf(DisBuf,"%01d",WorkTens);
	           OLED_ShowString(70,2,DisBuf,16);
					   sprintf(DisBuf,"%01d",WorkOnes);							
	           OLED_Show_Negative_String(78,2,DisBuf,16);
							
					   sprintf(DisBuf,"%01d%01d",RestTens,RestOnes);
	           OLED_ShowString(70,4,DisBuf,16);
						}
						else if(key==2)
						{
						 WorkTens++;
							if(WorkTens>9)
								WorkTens=0;
						 sprintf(DisBuf,"%01d",WorkTens);
	           OLED_Show_Negative_String(70,2,DisBuf,16);												
						}			
		break;
		case 41:
			    if(key==1)
						{
						 PageState=42;
						 sprintf(DisBuf,"%01d%01d",WorkTens,WorkOnes);
	           OLED_ShowString(70,2,DisBuf,16);
							
					   sprintf(DisBuf,"%01d",RestTens);							
	           OLED_Show_Negative_String(70,4,DisBuf,16);
							
					   sprintf(DisBuf,"%01d",RestOnes);							
	           OLED_ShowString(78,4,DisBuf,16);												   
						}
						else if(key==2)
						{
						 WorkOnes++;
							if(WorkOnes>9)
								WorkOnes=0;
						 sprintf(DisBuf,"%01d",WorkOnes);
	           OLED_Show_Negative_String(78,2,DisBuf,16);												
						}			
		break;
		case 42:
			    if(key==1)
						{
						 PageState=43;
						 sprintf(DisBuf,"%01d%01d",WorkTens,WorkOnes);
	           OLED_ShowString(70,2,DisBuf,16);
							
					   sprintf(DisBuf,"%01d",RestTens);							
	           OLED_ShowString(70,4,DisBuf,16);
							
					   sprintf(DisBuf,"%01d",RestOnes);							
	           OLED_Show_Negative_String(78,4,DisBuf,16);												   
						}
						else if(key==2)
						{
						 RestTens++;
							if(RestTens>9)
								RestTens=0;
						 sprintf(DisBuf,"%01d",RestTens);
	           OLED_Show_Negative_String(70,4,DisBuf,16);												
						}			
		break;
		case 43:
			    if(key==1)
						{
						 PageState=44;
						 OLED_Clear();
						 SaveSet();
						 CycleCount_Work= WorkTens*10+WorkOnes;							
						 CycleCount_Rest= RestTens*10+RestOnes; //ѭѵ
					   OLED_ShowCHinese(40,0,43); //					 
					   OLED_ShowCHinese(72,0,44); //
						 CycleCount_Num=0;//
							
						 CycleCount_Num=0;//							
						 sprintf(DisBuf,"[%01d]",CycleCount_Num);
	           OLED_ShowString(0,4,DisBuf,16);
							
					   sprintf(DisBuf,"%02d",CycleCount_Work);
	           OLED_ShowString(48,2,DisBuf,32);
							
					   OLED_ShowCHinese(96,6,0); //
             OLED_ShowCHinese(112,6,1);//ʼ
							
             OLED_ShowCHinese(0,6,10); //
             OLED_ShowCHinese(16,6,11);//											   
						}
						else if(key==2)
						{
						 RestOnes++;
							if(RestOnes>9)
								RestOnes=0;
						 sprintf(DisBuf,"%01d",RestOnes);
	           OLED_Show_Negative_String(78,4,DisBuf,16);												
						}			
		break;
		case 44:
						if(key==1)
						{
						 PageState=45;
																											
						 TIM_INIT_Config();													
						 OLED_ShowCHinese(0,6,38); //
             OLED_ShowCHinese(16,6,38);//
							
						 OLED_ShowCHinese(96,6,2); //ͣ
             OLED_ShowCHinese(112,6,3);//ֹ							
            }	
						else if(key==2)  //
						{
						 PageState=3; //
						 OLED_Clear();
						 BEEP_Time=12;//ط
             ShowMenu3Page(40);						
						}
		break;
		case 45:     //
						if(key==1) 
						{
						   PageState=46; //ֹͣ
			         DisTIM3();
							 BEEP_Time=12;//ط
		           OLED_ShowCHinese(0,6,6); //
               OLED_ShowCHinese(16,6,7);//λ	
		
		           OLED_ShowCHinese(96,6,25); //
               OLED_ShowCHinese(112,6,26);//																			
						}			
    break;			
		case 46:
			      if(key==1)
						{
						 PageState=45;																											
						 TIM_INIT_Config();					
							
						 OLED_ShowCHinese(0,6,38); //
             OLED_ShowCHinese(16,6,38);//
							
						 OLED_ShowCHinese(96,6,2); //ͣ
             OLED_ShowCHinese(112,6,3);//ֹ						
						}
			      else if(key==2)
						{
						 PageState=44;
						 OLED_Clear();
						 CycleCount_Work= WorkTens*10+WorkOnes;							
						 CycleCount_Rest= RestTens*10+RestOnes; //ѭѵ
					   OLED_ShowCHinese(40,0,43); //					 
					   OLED_ShowCHinese(72,0,44); //
							
						 CycleCount_Num=0;//							
						 sprintf(DisBuf,"[%01d]",CycleCount_Num);
	           OLED_ShowString(0,4,DisBuf,16);
							
					   sprintf(DisBuf,"%02d",CycleCount_Work);
	           OLED_ShowString(48,2,DisBuf,32);
							
					   OLED_ShowCHinese(96,6,0); //
             OLED_ShowCHinese(112,6,1);//ʼ
							
             OLED_ShowCHinese(0,6,10); //
             OLED_ShowCHinese(16,6,11);//											   
						}					
		break;
						
		case 50:
					if(key==1)
						{
							PageState=51;
						  sprintf(DisBuf,"%01d",Now.HourTens);
	            OLED_ShowString(20,2,DisBuf,32);
							sprintf(DisBuf,"%01d",Now.HourOnes);
	            OLED_Show_Negative_String(36,2,DisBuf,32);	
						}
					else if(key==2)	
					  {
							Now.HourTens++;
							if(Now.HourTens>2)
								Now.HourTens=0;
							sprintf(DisBuf,"%01d",Now.HourTens);
	            OLED_Show_Negative_String(20,2,DisBuf,32);		 
						}	
		break;
		case 51:
					if(key==1)
						{
							PageState=52;
						  sprintf(DisBuf,"%01d",Now.HourOnes);
	            OLED_ShowString(36,2,DisBuf,32);
							sprintf(DisBuf,"%01d",Now.MinuteTens);
	            OLED_Show_Negative_String(68,2,DisBuf,32);	
						}
					else if(key==2)	
					  {
							Now.HourOnes++;
							if(Now.HourOnes>9)
								Now.HourOnes=0;
							sprintf(DisBuf,"%01d",Now.HourOnes);
	            OLED_Show_Negative_String(36,2,DisBuf,32);		 
						}	
		break;
		case 52:
					if(key==1)
						{
							PageState=53;
						  sprintf(DisBuf,"%01d",Now.MinuteTens);
	            OLED_ShowString(68,2,DisBuf,32);
							sprintf(DisBuf,"%01d",Now.MinuteOnes);
	            OLED_Show_Negative_String(84,2,DisBuf,32);	
						}
					else if(key==2)	
					  {
							Now.MinuteTens++;
							if(Now.MinuteTens>5)
								Now.MinuteTens=0;
							sprintf(DisBuf,"%01d",Now.MinuteTens);
	            OLED_Show_Negative_String(68,2,DisBuf,32);		 
						}	
		break;
		case 53:
					if(key==1)
						{
							PageState=54;
						  sprintf(DisBuf,"%01d",Now.MinuteOnes);
	            OLED_ShowString(84,2,DisBuf,32);
				    	sprintf(DisBuf,"%01d",Now.MonthTens);
            	OLED_Show_Negative_String(32,0,DisBuf,16);
						}
					else if(key==2)	
					  {
							Now.MinuteOnes++;
							if(Now.MinuteOnes>9)
								Now.MinuteOnes=0;
							sprintf(DisBuf,"%01d",Now.MinuteOnes);
	            OLED_Show_Negative_String(84,2,DisBuf,32);		 
						}	
		break;
		case 54:
					if(key==1)
						{
							PageState=55;
				    	sprintf(DisBuf,"%01d",Now.MonthTens);
            	OLED_ShowString(32,0,DisBuf,16);
				    	sprintf(DisBuf,"%01d",Now.MonthOnes);
	            OLED_Show_Negative_String(40,0,DisBuf,16);
						}
					else if(key==2)	
					  {							
							Now.MonthTens++;
							if(Now.MonthTens>1)
								Now.MonthTens=0;
							sprintf(DisBuf,"%01d",Now.MonthTens);
	            OLED_Show_Negative_String(32,0,DisBuf,16);
								 
						}	
		break;
		case 55:
					if(key==1)
						{
							PageState=56;
				    	sprintf(DisBuf,"%01d",Now.MonthOnes);
            	OLED_ShowString(40,0,DisBuf,16);
				    	sprintf(DisBuf,"%01d",Now.DateTens);
	            OLED_Show_Negative_String(64,0,DisBuf,16);
						}
					else if(key==2)	
					  {
		          Now.MonthOnes++;
							if(Now.MonthOnes>9)
								Now.MonthOnes=0;
							sprintf(DisBuf,"%01d",Now.MonthOnes);
	            OLED_Show_Negative_String(40,0,DisBuf,16);	
						}	
		break;
		case 56:
					if(key==1)
						{
							PageState=57;
				    	sprintf(DisBuf,"%01d",Now.DateTens);
            	OLED_ShowString(64,0,DisBuf,16);
				    	sprintf(DisBuf,"%01d",Now.DateOnes);
	            OLED_Show_Negative_String(72,0,DisBuf,16);
						}
					else if(key==2)	
					  {
		          Now.DateTens++;
							if(Now.DateTens>3)
								Now.DateTens=0;
							sprintf(DisBuf,"%01d",Now.DateTens);
	            OLED_Show_Negative_String(64,0,DisBuf,16);	
						}	
		break;
		case 57:
					if(key==1)
						{
							PageState=58;
				    	sprintf(DisBuf,"%01d",Now.DateOnes);
	            OLED_ShowString(72,0,DisBuf,16);
							
              OLED_ShowCHinese(0,6,10); //
              OLED_ShowCHinese(16,6,11);//			
					
				    	OLED_ShowCHinese(96,6,30); //Уʱ
              OLED_ShowCHinese(112,6,14);//
						}
					else if(key==2)	
					  {
		          Now.DateOnes++;
							if(Now.DateOnes>9)
								Now.DateOnes=0;
							sprintf(DisBuf,"%01d",Now.DateOnes);
	            OLED_Show_Negative_String(72,0,DisBuf,16);	
						}	
		break;
		case 58:
			   if(key==1)
				 {				  
					 SaveDate(Now);
					 SaveTime(Now);

				 	 PageState=100;
					 OLED_Clear();
           ShowDateTimePage();          			 				 				 
				 }
				 else if(key==2)	
					{
					 PageState=4;
					 OLED_Clear();
           ShowMenu4Page(40);						
				  }
		break;
		case 60:
			    PageState=100;
		      OLED_Clear();
		      ShowDateTimePage();
    break;
    default:
    break;			
	}		
		if(key==2 && BEEP_STATE==0 && PageState ==11) //ƴ
		{
		  BEEP(2700);
			LedDis(COLOR_GREEN);
		}
}

void ShowDeskpage() //0 
{
  if(PageState==100)
	{
		GetVolt(); //µѹ
	 sprintf(DisBuf,"%0.1fV",volt);
	 OLED_ShowString(48,6,DisBuf,16);
	
	 RTC_GetDateTime(&Time);	 //ʱ
	 sprintf(DisBuf,"%02d:%02d",Time.Hour,Time.Minute);
	 OLED_ShowString(20,2,DisBuf,32);	
	
	 sprintf(DisBuf,"%02d",Time.Month);
	 OLED_ShowString(32,0,DisBuf,16);
	 OLED_ShowCHinese(48,0,31);//
	 sprintf(DisBuf,"%02d",Time.Date);
	 OLED_ShowString(64,0,DisBuf,16);
	 OLED_ShowCHinese(80,0,32);//
	}
}

void ShowClockpage()//1 
{
  if(PageState==11)
	{
		sprintf(DisBuf,"%02d;%02d<%02d",TotalClock.ClockM,TotalClock.ClockS,TotalClock.Clock10xMS);
	  OLED_ShowString(0,2,DisBuf,32);		
	}
}

void ShowRatepage() //2 
{
  if(PageState==24)
		{
	    sprintf(DisBuf,"%02d'%02d\"%02d",TotalClock.ClockM,TotalClock.ClockS,TotalClock.Clock10xMS);
	    OLED_ShowString(32,0,DisBuf,16);	  	
  	  if(RateTimes>(6000/RATE) && BEEP_STATE==0) //RATE ÿӴ->ٸ10msһ 
	      {
		      RateTimes=0;
			    BEEP(2700);
		      LedDis(COLOR_GREEN);
		    }
		}
}
u8 CountNUM=1;
void ShowCountdownpage()//3 ʱ
{
	if(PageState==37)
	{
    if(CountNUM!=TotalClock.ClockS)	  //ϴεֵͱαȽ 
		 {
			 CountNUM=TotalClock.ClockS;
			 			 
			sprintf(DisBuf,"%02d",CountdownS);
	    OLED_ShowString(96,2,DisBuf,32);
			sprintf(DisBuf,"%02d",CountdownM);
	    OLED_ShowString(48,2,DisBuf,32);
			sprintf(DisBuf,"%02d",CountdownH);
	    OLED_ShowString(0,2,DisBuf,32);		

      if(CountdownH==0&&CountdownM==0&&CountdownS<6)	//5е						 
				{
					BEEP(2700);
			    LedDis(COLOR_YELLOW);
				}				
			if(CountdownS>0)
			   CountdownS--;
			else 
				{
					if(CountdownM>0)
					  {
						 CountdownS=59;
					   CountdownM--;
					  }
					else 
					 {						
					   if(CountdownH>0)						 
						 { 
							 CountdownS=59;
							 CountdownM=59;
   						 CountdownH--;
						 }
						 else
							 	{
                   PageState=36;//ʱʱ䵽
									 CountNUM=1;//ֵҪ0ʼ
									 DisTIM3();
		               BEEP(2700);
			             
					         OLED_ShowCHinese(96,6,0); //
                   OLED_ShowCHinese(112,6,1);//ʼ							
                   OLED_ShowCHinese(0,6,10); //
                   OLED_ShowCHinese(16,6,11);//
									 LedDis(COLOR_RED);
						  	}	
					  }
				 }						 
		  }
		}
}

u8 CycleCountClock=1;
u8 CycleCountState=1; //1Ϊ0ΪϢ
void ShowCycleCountpage()//4 ѭѵ 
{
	if(PageState==45)
	{		
    if(CycleCountClock!=TotalClock.ClockS)	  //ϴεֵͱαȽ 
		 {
			 CycleCountClock=TotalClock.ClockS;
			 			 			 
				if(CycleCountState)										
				  {
					   sprintf(DisBuf,"%02d",CycleCount_Work);
	           OLED_ShowString(48,2,DisBuf,32);	
						 OLED_ShowCHinese(40,0,43); //					 
					   OLED_ShowCHinese(72,0,44); //
						 if(CycleCount_Work>0)
               CycleCount_Work--;
             else	
						 {
							 CycleCountState=0;	
               BEEP(2700);			
               LedDis(COLOR_BLUE);							 
						   CycleCount_Rest= RestTens*10+RestOnes; //ѭѵ
						 }
				 }
				else
					{
						 sprintf(DisBuf,"%02d",CycleCount_Rest);
	           OLED_ShowString(48,2,DisBuf,32);	
						 OLED_ShowCHinese(40,0,45); //Ϣ					 
					   OLED_ShowCHinese(72,0,46); //
						 if(CycleCount_Rest>0)
               CycleCount_Rest--;
             else	
						 {
							 CycleCountState=1;
							 BEEP(2700);
							 LedDis(COLOR_RED);
							 CycleCount_Num++;
							 sprintf(DisBuf,"<%01d>",CycleCount_Num);
	             OLED_ShowString(0,4,DisBuf,16);
							 
						   CycleCount_Work= WorkTens*10+WorkOnes;														 	
						 }					
					}	
			if(CycleCount_Work<3&&CycleCountState==1)   //3е						 
				{
					BEEP(2700);
			    LedDis(COLOR_BLUE);
				}
			else if(CycleCount_Rest<3&&CycleCountState==0)	
			 {
					BEEP(2700);
			    LedDis(COLOR_RED);			
			 }					
			}
		}		 
}

u8 TimeIconNUM;
void ShowTimeIcon() //ʾɳ©ͼ
{
  if(PageState==11||PageState==24||PageState==37||PageState==45)
		{
			OLED_Show16x16Icon(56,6,TimeIconNUM);
			TimeIconNUM++;
			if(TimeIconNUM>7)
				TimeIconNUM=0;			
		}
}

/*****************ʼб**********/
typedef struct{   
	      void (*fun)(void);      //Ŀ꺯/
	      u32 uLenTick;           //ÿʱִһκ
	      u32 startTick;          //  ¼ʼʱ
	      u32  tcnt;              //  ¼ۻ˶ʱ
	}sTask;

static sTask mTaskTab[] =    
	{   	     			          
	   {GetPage,           SCANTIME_50MS}
		,{ShowDeskpage,      SCANTIME_1000MS}  //0
		,{ShowClockpage,     SCANTIME_10MS}    //1
		,{ShowRatepage,      SCANTIME_10MS}    //2
		,{ShowCountdownpage, SCANTIME_500MS}   //3ʱ
		,{ShowCycleCountpage,SCANTIME_500MS}   //4ѭѵ
		,{ShowTimeIcon,      SCANTIME_200MS}   //ɳ©ͼ
		,{GetPowerMode,      SCANTIME_1000MS}  //ʱػ
		,{IWDG_Feed,         SCANTIME_500MS}   //Ź
	};
/**********************************************/	
int main(void)
{
	u8 i;
	u32 Tnow=0;
	u8 len;
	
	SYSTICK_Init();
/* Flash read protection */	
#if FLASH_PROTECTION
	Flash_OB_Protection();
#endif 

	I2C1_init();
	delay_ms(20);	//ʱlis3dhῨ.
	
	WS2812_Int();
  PowerSW_Init();
	PowerSW_OFF(); //ΧԴ
	HALL_Init();
	KEY_Init();
	ADC_init();
	delay_ms(20);
	
	TIM_PWM_GPIO_Config();
	
	OLED_Init();
//	OLED_Clear(); 
	
	ReadSet();//ȡֵ
	if(IWDGFlag==1)
	{	 
		 IWDGFlag=0; //´
	   SaveSet();
	   enter_stop_mode();	//治ֱִӽ״̬
	}
	else
	{
	 IWDGFlag=1;
	 SaveSet();
	 IWDG_Int();
	}
	
 	RTC_Initializes();
  ShowDateTimePage();
  PageState==100;
	
  while (1)
  {			
		CheckBEEP();
	/********************************************/
      for (i = 0; i < ARRAYSIZE(mTaskTab); i++)   //ȽÿʱǷﵽ
       {				 
			  Tnow=SysTick->VAL;
			
		 	  if(Tnow<mTaskTab[i].startTick)//ֵ
				   mTaskTab[i].tcnt=mTaskTab[i].startTick-Tnow;//SYSTICKݼһڼֵ
			  else 
				  mTaskTab[i].tcnt=SYS_RELOAD-Tnow+mTaskTab[i].startTick;	    //һֵ
			
			  if(mTaskTab[i].tcnt>=mTaskTab[i].uLenTick)	//ﵽִֵӦ
			    {				         
						mTaskTab[i].startTick=Tnow;  //¿ʼֵ
					  mTaskTab[i].fun(); 				   //ִк
					  mTaskTab[i].tcnt=0;          //ֵ
			    }				
	      }	
  /**********************END**********************/	
	}
		
}

void EXTI2_3_IRQHandler(void) //ťжϻ
{
  if(EXTI_GetITStatus(EXTI_Line3) != RESET)
  {
    EXTI_ClearITPendingBit(EXTI_Line3);
		SystemInit(); //ϵͳʱӳʼ
		SYSTICK_Init();
		PowerSW_OFF(); //ΧԴ
		NVIC_SystemReset();//λ
  }
}
